unit CalcCard;
{
DCI demo unit
This is a descendant of TBasicCard implementing a card specific function

Copyright (C) 2002 CHZ-Soft
You have a royalty-free right to use, modify, reproduce and 
distribute the files under this license or any modified
version or any derived work in any way you find useful, 
provided that: 

a) You agree that CHZ-Soft has no warranty, obligations or 
   liability for any of these files.

b) When distributing in source form: this license notice
   remains intact.

c) When distributing in binary form: you include the following 
   copyright notice in the program or documentation:
   Portions Copyright (C) 2002 CHZ-Soft
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ZCDCI1, ZCBCI_PAS;

type
  TCalcCard = class(TBasicCard)
  public
    function Connect: Boolean; override;
    function Calculator(var Expression: String): Boolean;
  end;

const WRONG_APPID_ERROR = $3000000;

procedure Register;

implementation

const AppID = 'BasicCard Mini-Calculator';

function TCalcCard.Connect: Boolean;
begin
 Result:= inherited Connect;
 if Result then
  if ApplicationID<>AppID then begin
   Disconnect;
   fError:= WRONG_APPID_ERROR;
   Result:= False;
  end;
end;

function TCalcCard.Calculator(var Expression: String): Boolean;
var Temp: String; Parm: ZCBCIPARM;
begin
 Temp:= Copy(Expression, 1, Length(Expression));
 SetLength(Temp,255);
 Parm.parmtype:= ZCBCISTRING;
 Parm.data.valstring.cbString:= Length(Temp);
 Parm.data.valstring.pString:= PChar(Temp);
 Result:= Transaction($20, $01, @Parm, 1);
 if Result then
  Expression:= String(Parm.data.valstring.pString);
end;  

procedure Register;
begin
  RegisterComponents('BasicCard', [TCalcCard]);
end;

end.
