unit ZCBCI_PAS;
{
/******************************************************************************/
/*                  Delphi version of API header files                        */
/******************************************************************************/
/* Copyright      : ZeitControl cardsystems GmbH 1999                         */
/* Author         : Michael Petig                                             */
/******************************************************************************/
/* Project        : BasicCard Command Interface                               */
/* Description    : Global Header                                             */
/* History        : 19990219 MP initial version                               */
/*                  19990420 MP add enhance support                           */
/*                  19990906 MP add ZCBCIOCXSTRING support                    */
/*                  20000522 WE add from New API                              */
/*		    20000823 RK add Complete Delphi support                   */
/******************************************************************************/
}

interface
Const
//=============================================================================
// #include <zccridef.h>  Global Header defines constants used by CRI
//=============================================================================

// #ifndef __ZCCRIDEF_H__
// #define __ZCCRIDEF_H__

///* Link option */
//#define ZCCRILINK APIENTRY
//#define ZCCRIENTRY ZCCRILINK


//* global values */
// #define ZCCRI_MAX_SERVICE_NAME 16
ZCCRI_MAX_SERVICE_NAME = 16;
// #define ZCCRI_MAX_READER_NAME  256
ZCCRI_MAX_READER_NAME  = 256;
// #define ZCCRI_MAX_ATR          34
ZCCRI_MAX_ATR = 34;
// #define ZCCRI_SEPARATOR        ':'
ZCCRI_SEPARATOR = ':';


//* Error values */
// #define ZCCRI_NOERROR                0UL
ZCCRI_NOERROR = $0;
// #define ZCCRI_ERROR_BASE             0x01000000UL
ZCCRI_ERROR_BASE = $01000000;
// #define ZCCRI_ERROR_PARM             (ZCCRI_ERROR_BASE + 0x0000UL)
ZCCRI_ERROR_PARM = ZCCRI_ERROR_BASE + $0;
// #define ZCCRI_ERROR_UNKOWN_READER    (ZCCRI_ERROR_BASE + 0x0001UL)
ZCCRI_ERROR_UNKOWN_READER = ZCCRI_ERROR_BASE + $1;
// #define ZCCRI_ERROR_READER_BUSY      (ZCCRI_ERROR_BASE + 0x0002UL)
ZCCRI_ERROR_READER_BUSY = ZCCRI_ERROR_BASE + $2;
// #define ZCCRI_ERROR_PROTOCOL         (ZCCRI_ERROR_BASE + 0x0003UL)
ZCCRI_ERROR_PROTOCOL = ZCCRI_ERROR_BASE + $3;
// #define ZCCRI_ERROR_MEM              (ZCCRI_ERROR_BASE + 0x0004UL)
ZCCRI_ERROR_MEM = ZCCRI_ERROR_BASE + $4;
// #define ZCCRI_ERROR_INITFAILED       (ZCCRI_ERROR_BASE + 0x0005UL)
ZCCRI_ERROR_INITFAILED = ZCCRI_ERROR_BASE + $5;
// #define ZCCRI_ERROR_MISC             (ZCCRI_ERROR_BASE + 0x0006UL)
ZCCRI_ERROR_MISC = ZCCRI_ERROR_BASE + $6;
// #define ZCCRI_ERROR_NO_CARD          (ZCCRI_ERROR_BASE + 0x0007UL)
ZCCRI_ERROR_NO_CARD = ZCCRI_ERROR_BASE + $7;
// #define ZCCRI_ERROR_NO_DEFAULT       (ZCCRI_ERROR_BASE + 0x0008UL)
ZCCRI_ERROR_NO_DEFAULT = ZCCRI_ERROR_BASE + $8;
// #define ZCCRI_CANCEL                 (ZCCRI_ERROR_BASE + 0x0009UL)
ZCCRI_CANCEL = ZCCRI_ERROR_BASE + $9;
// #define ZCCRI_ERROR_OVERFLOW         (ZCCRI_ERROR_BASE + 0x000AUL)
ZCCRI_ERROR_OVERFLOW = ZCCRI_ERROR_BASE + $A;
// #define ZCCRI_ERROR_NOT_SUPPORTED    (ZCCRI_ERROR_BASE + 0x000BUL)
ZCCRI_ERROR_NOT_SUPPORTED = ZCCRI_ERROR_BASE + $0B;


//* new with version 1.1 */
//* CRI feature values */
//#define ZCCRI_FEATURE_CHECKCARD        0x00000001UL  /* ZCCriCardInReader supported */
ZCCRI_FEATURE_CHECKCARD  = $1;         //  /* ZCCriCardInReader supported */

//#define ZCCRI_FEATURE_CHECKCARD_ATR    0x00000002UL  /* ZCCriCardInReader with ATR supported */
ZCCRI_FEATURE_CHECKCARD_ATR = $2;      //  /* ZCCriCardInReader with ATR supported */

//* CRI option values */
//#define ZCCRI_OPTION_FASTINIT          0x00000001UL  /* fast init, do not check for connected readers */
ZCCRI_OPTION_FASTINIT       = $1;      //  /* fast init, do not check for connected readers */

//#define ZCCRI_OPTION_WAITSERVICE       0x00000002UL  /* wait for service for example PC/SC resource manager */
ZCCRI_OPTION_WAITSERVICE    = $2;      //  /* wait for service for example PC/SC resource manager */


//* Service depended options should use upper 16 bits */




// ---[ end of include <zccri.h>  Global Header defines constants used by CRI ]-

//==============================================================================
// #include <zccrityp.h> Global Header defines types used by CRI
//==============================================================================
{$IFDEF ver100}  //Delphi 3
type DWORD = LongInt;      // 32 bit  nt
     PDWORD= ^LongInt;
     ULONG = LongInt;
     PULONG = ^LongInt;
     LONG  = LongInt;
     PLONG = ^Longint;
     SHORT = SmallInt;
     PSHORT= ^SmallInt;
     PWORD = ^Word;
     SINT   = SmallInt;
     PBYTE  =PChar;
     BOOL   = Boolean;
     PBOOL  = ^Boolean;
     PSINGLE = ^Single;
{$ELSE}      //Delphi 4
type DWORD = LongWord;      // 32 bit unsigned nt
     PDWORD= ^LongWord;
     ULONG = LongWord;
     PULONG = ^LongWord;
     LONG  = LongInt;
     PLONG = ^Longint;
     SHORT = SmallInt;
     PSHORT= ^SmallInt;
     PWORD = ^Word;
     SINT   = SmallInt;
     PBYTE  =PChar;
     BOOL   = Boolean;
     PBOOL  = ^Boolean;
     PSINGLE = ^Single;
{$ENDIF}

     //* common data types */
// typedef DWORD ZCCRIRET;  /* 32 bit CRI return value */
type ZCCRIRET = DWORD;
// typedef ZCCRIRET *PZCCRIRET;
     PZCCRIRET = ^ZCCRIRET;
//typedef WORD  ZCCRIVER;  /* 16 bit version number   */
type ZCCRIVER = WORD;  //* 16 bit version number   */
//typedef ZCCRIVER *PZCCRIVER;
type PZCCRIVER = ^ZCCRIVER;

// typedef DWORD ZCCRIHANDLE; /* 32 bit handle */
type ZCCRIHANDLE = DWORD;
// typedef ZCCRIHANDLE *PZCCRIHANDLE;
type PZCCRIHANDLE = ^ZCCRIHANDLE;
// typedef ZCCRIHANDLE ZCCRIREADER; /* reader handle */
type ZCCRIREADER = ZCCRIHANDLE;
// typedef ZCCRIREADER *PZCCRIREADER;
type PZCCRIREADER = ^ZCCRIREADER;

//* ---------- CRI service name ----------------------------------------------*/
// typedef CHAR ZCCRISERVICENAME[ZCCRI_MAX_SERVICE_NAME+1];
type ZCCRISERVICENAME = array[0..ZCCRI_MAX_SERVICE_NAME+1] of Byte;
// typedef CHAR *PZCCRISERVICENAME;
type PZCCRISERVICENAME = PChar;

//* ---------- CRI reader name -----------------------------------------------*/
// typedef CHAR ZCCRIREADERNAME[ZCCRI_MAX_READER_NAME+1];
type ZCCRIREADERNAME = array[0..ZCCRI_MAX_READER_NAME+1] of Byte;
// typedef CHAR *PZCCRIREADERNAME;
type PZCCRIREADERNAME = PChar;

//* CRI ATR (history only) */
// typedef struct _ZCCRIATR
// {
//	BYTE bLength;
//	BYTE abAtr[ZCCRI_MAX_ATR+1];
// } ZCCRIATR;

type ZCCRIATR = packed record
    bLength : Byte;
    abAtr : array[0..ZCCRI_MAX_ATR+1] of Byte;
end;

// typedef ZCCRIATR *PZCCRIATR;
type PZCCRIATR = ^ZCCRIATR;
// ---[ end of include <zccrityp.h>  Global Header defines types used by CRI ]--
// =============================================================================


//==============================================================================
// #include <zccriprt.h>  Global Header defines funtions used by CRI
//==============================================================================

//* API version 1.0 */
// #define ZCCRI_API      0x100
Const ZCCRI_API = $101;

// #define ZCCRI_API_1_0

{
/******************************************************************************/
/* Function       : ZCCriGetReaderCount                                       */
/* Description    : get number of known readers                               */
/* Parameter      : (OUT) *pCount number of known readers                     */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer          */
/******************************************************************************/
/* History        : 19990211 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriGetReaderCount(PULONG pCount);
}
function ZCCriGetReaderCount(pCount:PULONG):ZCCRIRET;stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriGetReaderName                                        */
/* Description    : get name of single reader supported by any service        */
/* Parameter      : (in) ulNum number of requested reader (0 .. readercount-1)*/
/*                  (OUT) *pName name of requested reader                     */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer          */
/*                  ZCCRI_ERROR_UNKOWN_READER reader not known, ulNum to big  */
/******************************************************************************/
/* History        : 19990211 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriGetReaderName(ULONG ulNum, PZCCRIREADERNAME pName);
}
function ZCCriGetReaderName(ulNum:ULONG;pName:PZCCRIREADERNAME):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriOpenReader                                           */
/* Description    : open reader                                               */
/* Parameter      : (out) *phReader handle to reader                          */
/*                  (in)  *pName name of requested reader (NULL for default)  */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer          */
/*                  ZCCRI_ERROR_UNKOWN_READER reader not known                */
/*                  ZCCRI_ERROR_READER_BUSY reader busy or not accessible     */
/******************************************************************************/
/* History        : 19990303 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriOpenReader(PZCCRIREADER phReader, PZCCRIREADERNAME pName);
}
function ZCCriOpenReader(phReader:PZCCRIREADER;pName:PZCCRIREADERNAME):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriCloseReader                                          */
/* Description    : close reader                                              */
/* Parameter      : (in) hReader handle to connection                         */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer          */
/******************************************************************************/
/* History        : 19990303 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriCloseReader(ZCCRIREADER hReader);
}
function ZCCriCloseReader(hReader:ZCCRIREADER):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriWaitCard                                             */
/* Description    : wait timout ms for card to be inserted                    */
/* Parameter      : (in) hReader handle to connection                         */
/*                  (in) lTimeout timeout in ms (0 no wait, -1 infinite wait) */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer          */
/*                  ZCCRI_ERROR_NO_CARD no card in reader                     */
/*                  ZCCRI_ERROR_READER_BUSY reader busy                       */
/******************************************************************************/
/* History        : 19990303 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriWaitCard(ZCCRIREADER hReader, LONG lTimeout);
}
function ZCCriWaitCard(hReader:ZCCRIREADER;lTimeout:LONG):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriConnect                                              */
/* Description    : connect to card in given reader                           */
/* Parameter      : (in) hReader handle to reader                             */
/*                  (OUT) *pAtr card ATR NOTE pAtr may be NULL                */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer          */
/*                  ZCCRI_ERROR_UNKOWN_READER reader not known                */
/*                  ZCCRI_ERROR_READER_BUSY reader busy or not accessible     */
/*                  ZCCRI_ERROR_NO_CARD no card in reader                     */
/******************************************************************************/
/* History        : 19990211 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriConnect(ZCCRIREADER hReader, PZCCRIATR pAtr);
}
function ZCCriConnect(hReader:ZCCRIREADER;pAtr:PZCCRIATR):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriReconnect                                            */
/* Description    : reconnect to card in reader or in other words reset card  */
/* Parameter      : (in) hReader handle to open connection                    */
/*                  (OUT) *pAtr card ATR NOTE pAtr may be NULL                */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer, invalid */
/*                                   handle                                   */
/*                  ZCCRI_ERROR_NO_CARD no card in reader                     */
/******************************************************************************/
/* History        : 19990211 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriReconnect(ZCCRIREADER hReader, PZCCRIATR pAtr);
}

function ZCCriReconnect(hReader:ZCCRIREADER;pAtr:PZCCRIATR):ZCCRIRET;
                                                  stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriDisconnect                                           */
/* Description    : disconnect from card and reader                           */
/* Parameter      : (in) hReader handle to open connection                    */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, invalid handle        */
/******************************************************************************/
/* History        : 19990211 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriDisconnect(ZCCRIREADER hReader);
}

function ZCCriDisconnect(hReader:ZCCRIREADER):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriTransaction                                          */
/* Description    : send (and receive) T1 transaction to smartcard            */
/* Parameter      : (in) hReader handle to open connection                    */
/*                  (in) *pDataIn input data (Cla, Ins, P1, P2, ..)           */
/*                  (in) cbData   size of input data                          */
/*                  (out) *pReply reply data                                  */
/*                  (in/out) *pcbReply (in) size of reply buffer              */
/*                                     (out) number of bytes received         */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer,         */
/*                                   invalid handle                           */
/*                  ZCCRI_ERROR_PROTOCOL protocol error transaction failed    */
/*                  ZCCRI_ERROR_NO_CARD no card in reader                     */
/*                  ZCCRI_ERROR_OVERFLOW buffer (pReply) overflow             */
/******************************************************************************/
/* History        : 19990211 MP initial version                               */
/*                  19990303 MP completly change call                         */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriTransaction(ZCCRIREADER hReader,
                                      BYTE *pDataIn, DWORD cbDataIn,
                                      BYTE *pReply, DWORD *pcbReply);

}

function ZCCriTransaction(hReader:ZCCRIREADER;pDataIn:PChar;cbDataIn:DWORD;
                          pReply:PChar;pcbReply:PDWORD):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';
{
/******************************************************************************/
/* Function       : ZCCriTransaction2                                         */
/* Description    : send (and receive) T1 transaction to smartcard            */
/* Parameter      : (in) hReader handle to open connection                    */
/*                  (in) Cla  class byte                                      */
/*                  (in) Ins  instruction byte                                */
/*                  (in) P1   parameter 1                                     */
/*                  (in) P2   parameter 2                                     */
/*                  (in) Lc   length of additional data                       */
/*                  (in) *pData additional data                               */
/*                  (in) Le   length of expected reply (0..254 or -1 to omit) */
/*                  (out) *pReply reply data (without SW1, SW2) may be NULL   */
/*                  (in/out) *pcbReply (in) length of reply buffer pReply     */
/*                                    (out) received length of data (without  */
/*                                          SW1SW2)                           */
/*                  (out) *pSW1SW2 SW1, SW2                                   */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer,         */
/*                                   invalid handle                           */
/*                  ZCCRI_ERROR_PROTOCOL protocol error transaction failed    */
/*                  ZCCRI_ERROR_NO_CARD no card in reader                     */
/******************************************************************************/
/* History        : 19990303 MP initial version                               */
/*                  19990421 MP change reply lentgth, le parameter add cbReply*/
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriTransaction2(ZCCRIREADER hReader, BYTE Cla, BYTE Ins,
				     BYTE P1, BYTE P2, BYTE Lc, BYTE *pData,
				     SHORT Le, BYTE *pReply, SHORT *pcbReply,
				        			 WORD *pSW1SW2);
}

function ZCCriTransaction2(hReader:ZCCRIREADER;Cla:Byte;Ins:Byte;P1:Byte;P2:Byte;
                                   Lc:Byte;pData:PChar;Le:SHORT;pReply:PChar;
                                   pcbReply:PSHORT;pSW1SW2:PWORD):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';


{
/******************************************************************************/
/* Function       : ZCCriSetLogFile                                           */
/* Description    : logs all input and output data to log file                */
/* Parameter      : (in) hReader handle to open connection                    */
/*                  (in) pszFile name of log file or NULL to disable          */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer,         */
/*                                   invalid handle                           */
/*                  ZCCRI_ERROR_MISC unable to open file                      */
/******************************************************************************/
/* History        : 19990305 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriSetLogFile(ZCCRIREADER hReader, CHAR *pszFile);
}

function ZCCriSetLogFile(hReader:ZCCRIREADER;pszFile:PChar):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriRegisterService                                      */
/* Description    : register a RWL service dll                                */
/* Parameter      : CHAR *pszService                                          */
/*                  CHAR *pszDllName DLL to register                          */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer          */
/*                  ZCCRI_ERROR_MISC unknown error                            */
/******************************************************************************/
/* History        : 19990215 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriRegisterService(CHAR *pszService, CHAR *pszDLLName);
}

function ZCCriRegisterService(pszService:PChar;pszDLLName:PChar):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriDeregisterService                                    */
/* Description    : deregister a RWL service dll                              */
/* Parameter      : CHAR *pszService service to deregister                    */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer          */
/*                  ZCCRI_ERROR_MISC unknown error                            */
/******************************************************************************/
/* History        : 19990215 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriDeregisterService(CHAR *pszService);
}

function ZCCriDeregisterService(pszService:PChar):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriSetDefaultReader                                     */
/* Description    : set default reader used when NULL or empty String is used */
/*                  as reader name in ZCCriConnect                            */
/* Parameter      : (in) *pName name of requested reader                      */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer          */
/*                  ZCCRI_ERROR_MISC unknown error                            */
/******************************************************************************/
/* History        : 19990211 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriSetDefaultReader(PZCCRIREADERNAME pName);
}

function ZCCriSetDefaultReader(pName:PZCCRIREADERNAME):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriGetDefaultReader                                     */
/* Description    : get default reader used when NULL or empty String is used */
/*                  as reader name in ZCCriConnect                            */
/* Parameter      : (out) *pName name of requested reader                     */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer          */
/*                  ZCCRI_ERROR_NO_DEFAULT no default reader                  */
/******************************************************************************/
/* History        : 19990211 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriGetDefaultReader(PZCCRIREADERNAME pName);
}

function ZCCriGetDefaultReader(pName:PZCCRIREADERNAME):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriSelectReaderDialog                                   */
/* Description    : show dialog to select reader                              */
/* Parameter      : (out) *pName name of selected reader                      */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter, null pointer          */
/*                  ZCCRI_CANCEL dialog canceled                              */
/******************************************************************************/
/* History        : 19990211 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriSelectReaderDialog(PZCCRIREADERNAME pName);
}

function ZCCriSelectReaderDialog(pName:PZCCRIREADERNAME):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{/* new with version 1.1 */
/******************************************************************************/
/* Function       : ZCCriGetFeatures                                          */
/* Description    : return features supported by give reader, service         */
/* Parameter      : (in)  pName  name of reader, service (e.g. "PCSC:") or    */
/*                        NULL for default readerto query                     */
/*                  (out) *pdwFeatures bitmap of ZCCRI_FEATURE_...            */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter                        */
/*                  ZCCRI_ERROR_UNKOWN_READER reader not known                */
/******************************************************************************/
/* History        : 20000114 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriGetFeatures(PZCCRIREADERNAME pName, DWORD *pdwFeatures);
}
function ZCCriGetFeatures(pName:PZCCRIREADERNAME; pdwFeatures : PDWORD):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';
{
/******************************************************************************/
/* Function       : ZCCriCardInReader                                         */
/* Description    : Check if card is in reader without open, block reader     */
/*                  If supported ZCCRI_FEATURE_CHECKCARD will be returned by  */
/*                  ZCCriGetFeatures. If supported with returning ATR         */
/*                  ZCCRI_FEATURE_CHECKCARD_ATR will also be returned         */
/* Parameter      : (in)  pName  name of reader to query                      */
/*                  (out) *pAtr  ATR of card in reader (if supported)         */
/* Returnvalue    : ZCCRI_NOERROR  no error (card in reader)                  */
/*                  ZCCRI_ERROR_NO_CARD no card in reader                     */
/*                  ZCCRI_ERROR_PARM invalid parameter                        */
/*                  ZCCRI_ERROR_UNKOWN_READER reader not known                */
/*                  ZCCRI_ERROR_NOT_SUPPORTED this call is not supported by   */
/*                                            this reader or service          */
/******************************************************************************/
/* History        : 20000114 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriCardInReader(PZCCRIREADERNAME pName, PZCCRIATR pAtr);

}
function ZCCriCardInReader(pName:PZCCRIREADERNAME;pAtr:PZCCRIATR):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriSetOptions                                           */
/* Description    : set options for open reader                               */
/* Parameter      : (in)  hReader handle of reader to set                     */
/*                  (in)  dwOptions bitmap of ZCCRI_OPTION_...                */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter                        */
/*                  ZCCRI_ERROR_UNKOWN_READER reader not known                */
/*                  ZCCRI_ERROR_NOT_SUPPORTED not supported by this service   */
/******************************************************************************/
/* History        : 20000114 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriSetOptions(ZCCRIREADER hReader, DWORD dwOptions);
}

function ZCCriSetOptions(hReader:ZCCRIREADER;dwOptions:DWORD):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';


{
/******************************************************************************/
/* Function       : ZCCriGetOptions                                           */
/* Description    : get options for open reader                               */
/* Parameter      : (in)  hReader handle of reader to get                     */
/*                  (out)  *pdwOptions bitmap of ZCCRI_OPTION_...             */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter                        */
/*                  ZCCRI_ERROR_UNKOWN_READER reader not known                */
/*                  ZCCRI_ERROR_NOT_SUPPORTED not supported by this service   */
/******************************************************************************/
/* History        : 20000114 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriGetOptions(ZCCRIREADER hReader, DWORD *pdwOptions);
}
function ZCCriGetOptions(hReader:ZCCRIREADER;pdwOptions:PDWORD):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriSetOptions2                                          */
/* Description    : set options for all or single service                     */
/*                  Note: When use for ZCCRI_OPTION_FASTINIT this must be     */
/*                        first call to ZCCri... functions and pServiceName   */
/*                        must be NULL                                        */
/* Parameter      : (in)  pServiceName name of service to set or NULL for all */
/*                                     services                               */
/*                  (in)  dwOptions bitmap of ZCCRI_OPTION_...                */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter                        */
/*                  ZCCRI_ERROR_UNKOWN_READER reader not known                */
/*                  ZCCRI_ERROR_NOT_SUPPORTED not supported by this service   */
/******************************************************************************/
/* History        : 20000114 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriSetOptions2(PZCCRISERVICENAME pServiceName, DWORD dwOptions);
}

function ZCCriSetOptions2(pServiceName:PZCCRISERVICENAME;dwOptions:DWORD):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';

{
/******************************************************************************/
/* Function       : ZCCriGetOptions2                                          */
/* Description    : get options for single service                            */
/* Parameter      : (in)  pServiceName name of service to set                 */
/*                                     services                               */
/*                  (out)  *pdwOptions bitmap of ZCCRI_OPTION_...             */
/* Returnvalue    : ZCCRI_NOERROR  no error                                   */
/*                  ZCCRI_ERROR_PARM invalid parameter                        */
/*                  ZCCRI_ERROR_UNKOWN_READER reader not known                */
/*                  ZCCRI_ERROR_NOT_SUPPORTED not supported by this service   */
/******************************************************************************/
/* History        : 20000114 MP initial version                               */
/******************************************************************************/
ZCCRIRET ZCCRILINK ZCCriGetOptions2(PZCCRISERVICENAME pServiceName, DWORD *pdwOptions);
}
function ZCCriGetOptions2(PServiceName:PZCCRISERVICENAME;pdwOptions:PDWORD):ZCCRIRET;
                                                   stdcall;external 'ZCCRI.DLL';


//=============================================================================
//  Includefile zcbci.h
//=============================================================================


///* typedefs */
// #pragma pack(1)
// typedef DWORD ZCBCIRET;
type ZCBCIRET = DWORD;
// typedef ZCBCIRET *PZCBCIRET;
type PZCBCIRET = ^ZCBCIRET;
// typedef DWORD ZCBCIHANDLE;
type ZCBCIHANDLE = DWORD;
// typedef ZCBCIHANDLE *PZCBCIHANDLE;
type PZCBCIHANDLE = ^ZCBCIHANDLE;
// typedef ZCBCIHANDLE ZCBCICARD;
type ZCBCICARD = ZCBCIHANDLE;
// typedef ZCBCICARD *PZCBCICARD;
type PZCBCICARD = ^ZCBCICARD;

// typedef enum _ZCBCIPARMTYPE
// {
// 	ZCBCIBYTE,
// 	ZCBCIINT,
// 	ZCBCILONG,
// 	ZCBCISTRING,
// 	ZCBCISTRINGN,
// 	ZCBCIUSER,
// 	ZCBCIRAW,       /* if used must be the one and only parameter */
// 	ZCBCIOCXSTRING  /* used by basiccard activeX control */
//      ZCBCINULL,      /* NULL/empty parameter */
//      ZCBCISINGLE,
//	ZCBCIDUMMY=0x7FFFFFFF /* make it use 32 bits */
// } ZCBCIPARMTYPE;
//

//type ZCBCIPARMTYPE =(ZCBCIBYTE,ZCBCIINT,ZCBCILONG,ZCBCISTRING,ZCBCISTRINGN,ZCBCIUSER,
//                     ZCBCIRAW,ZCBCIOCXSTRING);

type ZCBCIPARMTYPE = longint;
const 	ZCBCIBYTE = 0;
 	ZCBCIINT = 1;
 	ZCBCILONG = 2;
	ZCBCISTRING  = 3;
 	ZCBCISTRINGN = 4 ;
 	ZCBCIUSER =5;
 	ZCBCIRAW = 6; //       /* if used must be the one and only parameter */
 	ZCBCIOCXSTRING =7; //* used by basiccard activeX control */
        ZCBCIDUMMY = 8;
        ZCBCISINGLE = 9;
        ZCBCINULL = 10;      //* NULL/empty parameter */



// typedef BYTE  ZCBCIPARMBYTE;
type ZCBCIPARMBYTE = Byte;

// typedef ZCBCIPARMBYTE *PZCBCIPARMBYTE;
type PZCBCIPARMBYTE = ^ZCBCIPARMBYTE;

// typedef INT   ZCBCIPARMINT;
type ZCBCIPARMINT = SINT;

// typedef ZCBCIPARMINT *PZCBCIPARMINT;
type PZCBCIPARMINT = ^ZCBCIPARMINT;

// typedef LONG  ZCBCIPARMLONG;
type ZCBCIPARMLONG = LONG;

// typedef ZCBCIPARMLONG *PZCBCIPARMLONG;
type PZCBCIPARMLONG = ^ZCBCIPARMLONG;

//typedef FLOAT ZCBCIPARMSINGLE;
type ZCBCIPARMSINGLE = Single;

//typedef ZCBCIPARMSINGLE *PZCBCIPARMSINGLE;
type PZCBCIPARMSINGLE = ^ZCBCIPARMSINGLE;

// typedef struct _ZCBCIPARMSTRING
// {
// 	BYTE cbString;  /* BYTE size pString is able to hold (including '\0') */
// 	CHAR *pString;  /* '\0' terminated string */
// } ZCBCIPARMSTRING;
type ZCBCIPARMSTRING = packed record
     cbString: Byte;
     pString : PChar;
end;

// typedef ZCBCIPARMSTRING *PZCBCIPARMSTRING;
type PZCBCIPARMSTRING = ^ZCBCIPARMSTRING;

// typedef struct _ZCBCIPARMSTRINGN
// {
// 	BYTE bLength;   /* Length of string equals N */
// 	CHAR *pString;  /* '\0' terminated string */
// } ZCBCIPARMSTRINGN;
type ZCBCIPARMSTRINGN = packed record
     bLength : Byte;
     pString : Pchar;
end;

// typedef ZCBCIPARMSTRINGN *PZCBCIPARMSTRINGN;
type PZCBCIPARMSTRINGN = ^ZCBCIPARMSTRINGN;

// typedef struct _ZCBCIPARMUSER
// {
// 	BYTE bSize;     /* sizeof user type data */
// 	BYTE *pData;    /* user type data */
// } ZCBCIPARMUSER;
type ZCBCIPARMUSER = packed record
     bSize : Byte;
     pData : PChar;
end;
// typedef ZCBCIPARMUSER *PZCBCIPARMUSER;
type PZCBCIPARMUSER = ^ZCBCIPARMUSER;

// typedef struct _ZCBCIPARMRAW
// {
// 	BYTE bSize;     /* sizeof raw data buffer */
// 	BYTE bLen;      /* (in) length of send data, (out) length of receive data */
// 	BYTE *pData;    /* raw data buffer */
// } ZCBCIPARMRAW;
type ZCBCIPARMRAW = packed record
     bSize : Byte;
     bLen  : Byte;
     pData : PChar;
end;

// typedef struct _ZCBCIPARMOCXSTRING
// {
// 	BYTE bLength;   /* (in/out) Length of string equals N */
// 	BYTE *pString;  /* Pointer to byte array of at least 255 bytes */
// } ZCBCIPARMOCXSTRING;
type ZCBCIPARMOCXSTRING = packed record
        bLength : Byte;
        pString : PChar;
end;
// typedef ZCBCIPARMRAW *PZCBCIPARMRAW;
type PZCBCIPARMRAW = ^ZCBCIPARMRAW;

// typedef BYTE ZCBCIPARMDUMMY[12];
type ZCBCIPARMDUMMY = array [0..11] of Byte;

// typedef union _ZCBCIPARMDATA
// {
// 	ZCBCIPARMBYTE    valbyte;
// 	ZCBCIPARMINT     valint;
// 	ZCBCIPARMLONG    vallong;
// 	ZCBCIPARMSTRING  valstring;
// 	ZCBCIPARMSTRINGN valstringn;
// 	ZCBCIPARMUSER    valuser;
// 	ZCBCIPARMRAW     valraw;
// 	ZCBCIPARMOCXSTRING valocxstring;
// 	ZCBCIPARMDUMMY   donotuse;
// } ZCBCIPARMDATA;

type ZCBCIPARMDATA = record
   case integer of
//    0: (valbyte : ZCBCIPARMBYTE);
      0: (valbyte : ZCBCIPARMBYTE);//Byte);

//    1: (valint  : ZCBCIPARMINT);
      1: (valint  : ZCBCIPARMINT);//Word);

//    2: (vallong : ZCBCIPARMLONG);
      2: (vallong : ZCBCIPARMLONG);//DWORD);

//    3: (valstring : ZCBCIPARMSTRING);
      3: (valstring : ZCBCIPARMSTRING);

      4: (valstringn : ZCBCIPARMSTRINGN);

      5: (valuser : ZCBCIPARMUSER);
      6: (valraw  : ZCBCIPARMRAW);
      7: (valocxstring : ZCBCIPARMOCXSTRING);
      8: (donotuse : ZCBCIPARMDUMMY);
      9: (valsingle : ZCBCIPARMSINGLE);
end;

// typedef struct _ZCBCIPARM
// {
// 	ZCBCIPARMTYPE parmtype;
// 	ZCBCIPARMDATA data;
// } ZCBCIPARM;
type ZCBCIPARM = packed record
     parmtype:dword;
     data:ZCBCIPARMDATA;
end;
// (1) genauer Aufbau des Speicherabbildes Lnge in Byte
// para[0..3] = ZCBCIPARM
// wie sieht Para[0..



// typedef ZCBCIPARM *PZCBCIPARM;
type PZCBCIPARM = ^ZCBCIPARM;

// typedef struct _ZCBCILOCKINFO
// {
//   BYTE ReadLock;   /* liAllowed, liKeyed1, liKeyed2, or liForbidden */
//   BYTE WriteLock;  /* liAllowed, liKeyed1, liKeyed2, or liForbidden */
//   BYTE CustomLock; /* liAllowed, liUnlocked, or liLocked */
//   BYTE ReadKey[2]; /* Key number(s) for ReadLock */
//   BYTE WriteKey[2];/* Key number(s) for WriteLock */
// } ZCBCILOCKINFO;
type ZCBCILOCKINFO = packed record
     ReadLock : Byte;
     WriteLock: Byte;
     CustomLock:Byte;
     ReadKey: array[0..2] of Byte;
     WriteKey: array[0..2] of Byte;
end;
// typedef ZCBCILOCKINFO *PZCBCILOCKINFO;
type PZCBCILOCKINFO = ^ZCBCILOCKINFO;


// typedef enum _ZCBCILOCK
//{
//	ZCBCI_LOCK_CUSTOM=0x0,
//	ZCBCI_LOCK_READ  =0x4,
//	ZCBCI_LOCK_WRITE =0x8,
//	ZCBCI_LOCK_READWRITE=0xC,
//    ZCBCI_LOCK_DUMMY =0x7FFFFFFF /* make it use 32 bits */
// } ZCBCILOCK;
// typedef ZCBCILOCK *PZCBCILOCK;

// typedef ZCBCILOCK *PZCBCILOCK;
// #pragma pack()
type ZCBCILOCK = longint;
const 	ZCBCI_LOCK_CUSTOM = 0;
        ZCBCI_LOCK_READ   = 4;
        ZCBCI_LOCK_WRITE  = 8;
        ZCBCI_LOCK_READWRITE = $C;

type PZCBCILOCK = ^ZCBCILOCK;


//****************************************************************************
// Globals
//****************************************************************************

Const
//* error codes */
// #define ZCBCI_NOERROR                0UL
ZCBCI_NOERROR                           =$0;

// #define ZCBCI_ERROR_BASE             0x02000000UL
ZCBCI_ERROR_BASE                        =$2000000;

// #define ZCBCI_ERROR_PARM             (ZCBCI_ERROR_BASE + 0x0000UL)
ZCBCI_ERROR_PARM = ZCBCI_ERROR_BASE +   $0;

// #define ZCBCI_ERROR_MISC             (ZCBCI_ERROR_BASE + 0x0001UL)
ZCBCI_ERROR_MISC = ZCBCI_ERROR_BASE +   $1;

// #define ZCBCI_ERROR_MEM              (ZCBCI_ERROR_BASE + 0x0002UL)
ZCBCI_ERROR_MEM  = ZCBCI_ERROR_BASE +   $2;

// #define ZCBCI_ERROR_OVERFLOW         (ZCBCI_ERROR_BASE + 0x0003UL)
ZCBCI_ERROR_OVERFLOW = ZCBCI_ERROR_BASE + $3;

// #define ZCBCI_ERROR_TRANS_FAILED     (ZCBCI_ERROR_BASE + 0x0004UL)
ZCBCI_ERROR_TRANS_FAILED = ZCBCI_ERROR_BASE + $4;

// #define ZCBCI_ERROR_MISSING_PARM     (ZCBCI_ERROR_BASE + 0x0005UL)
ZCBCI_ERROR_MISSING_PARM = ZCBCI_ERROR_BASE + $5;

// #define ZCBCI_ERROR_INVALID_FILE     (ZCBCI_ERROR_BASE + 0x0006UL)
ZCBCI_ERROR_INVALID_FILE = ZCBCI_ERROR_BASE + $6;

// /* sw error codes */

// #define ZCBCI_ERROR_BASE_SW           0x04000000;
ZCBCI_ERROR_BASE_SW = $4000000;

// #define ZCBCI_SW2BCI(sw)              (((ZCBCIRET) ((WORD) (sw))) + ZCBCI_ERROR_BASE_SW)
// #define ZCBCI_IS_SW(e)                (((e) >= ZCBCI_ERROR_BASE_SW) && ((e) <= (ZCBCI_ERROR_BASE_SW+0xFFFF))
// #define ZCBCI_BCI2SW(e)               ((WORD) ((e) & 0xFFFF))

// /* card states */
// #define ZCBCI_STATE_NEW    0
ZCBCI_STATE_NEW            = $0;
// #define ZCBCI_STATE_LOAD   1
ZCBCI_STATE_LOAD           = $1;
// #define ZCBCI_STATE_TEST   2
ZCBCI_STATE_TEST           = $2;
// #define ZCBCI_STATE_RUN    3
ZCBCI_STATE_RUN            = $3;

// /* encryption algorithms */
// #define ZCBCI_DEFAULT_ENC  0
ZCBCI_DEFAULT_ENC          = $0;
// #define ZCBCI_SG_LFSR      0x11
ZCBCI_SG_LFSR              = $11;
// #define ZCBCI_SG_LFSR_CRC  0x12
ZCBCI_SG_LFSR_CRC          = $12;

// #ifdef ZCBCI_ENHANCED
// #define ZCBCI_DES          0x21
ZCBCI_DES                  =   $21;
// #define ZCBCI_3DES         0x22
ZCBCI_3DES                 =   $22;

// #endif

// /* special transaction values */
// #define ZCBCI_DEFAULT_LC   0xFFFF
ZCBCI_DEFAULT_LC           =   $FFFF;
// #define ZCBCI_DEFAULT_LE   0xFFFF
ZCBCI_DEFAULT_LE           =   $FFFF;
// #define ZCBCI_DISABLE_LE   0xFFFE
ZCBCI_DISABLE_LE           =   $FFFE;

// /* fileio modes */
// #define ZCBCI_MODE_APPEND  0x60
ZCBCI_MODE_APPEND            = $60;
// #define ZCBCI_MODE_BINARY 0x20
ZCBCI_MODE_BINARY            = $20;
// #define ZCBCI_MODE_INPUT  0x30
ZCBCI_MODE_INPUT             = $30;
// #define ZCBCI_MODE_OUTPUT 0x40
ZCBCI_MODE_OUTPUT            = $40;
// #define ZCBCI_MODE_RANDOM 0x50
ZCBCI_MODE_RANDOM            = $50;

// /* filio acess */
// #define ZCBCI_ACCESS_READ  0x04
ZCBCI_ACCESS_READ            = $04;
// #define ZCBCI_ACCESS_WRITE 0x08
ZCBCI_ACCESS_WRITE           = $08;

// #define ZCBCI_ACCESS_READWRITE (ZCBCI_ACCESS_READ | ZCBCI_ACCESS_WRITE)
ZCBCI_ACCESS_READWRITE       = (ZCBCI_ACCESS_READ or ZCBCI_ACCESS_WRITE);

// /* fileio sharing */
// #define ZCBCI_SHARE_SHARED        0x03
ZCBCI_SHARE_SHARED           =        $03;
// #define ZCBCI_SHARE_LOCKREAD      0x02
ZCBCI_SHARE_LOCKREAD         =        $02;
// #define ZCBCI_SHARE_LOCKWRITE     0x01
ZCBCI_SHARE_LOCKWRITE        =        $01;
// #define ZCBCI_SHARE_LOCKREADWRITE 0x00
ZCBCI_SHARE_LOCKREADWRITE    =        $00;

// /* Note: do not conncat ZCBCI_SHARE_LOCKREAD and ZCBCI_SHARE_LOCKWRITE by | */
// /*       use ZCBCI_SHARE_LOCKREADWRITE instead                              */

// /* SW1SW2 CODES */
// #ifdef ZCBCI_INCL_SW
// #define	swCommandOK           0x9000
// #define	swRetriesRemaining    0x63C0
// #define	swEepromWriteError    0x6581
// #define	swKeyNotFound         0x6611
// #define	swPolyNotFound        0x6612
// #define	swKeyTooShort         0x6613
// #define	swKeyDisabled         0x6614
// #define	swUnknownAlgorithm    0x6615
// #define	swAlreadyEncrypting   0x66C0
// #define	swNotEncrypting       0x66C1
// #define	swBadCommandCRC       0x66C2
// #define	swDesCheckError       0x66C3
// #define	swLcLeError           0x6700
// #define	swCommandTooLong      0x6781
// #define	swInvalidState        0x6985
// #define	swCardUnconfigured    0x6986
// #define	swNewStateError       0x6987
// #define	swP1P2Error           0x6A00
// #define	swOutsideEeprom       0x6A02
// #define	swDataNotFound        0x6A88
// #define	swINSNotFound         0x6D00
// #define	swCLANotFound         0x6E00
// #define	swNoCardReader        0x6782
// #define	swCardReaderError     0x6783
// #define	swNoCardInReader      0x6784
// #define	swCardPulled          0x6785
// #define	swT1Error             0x6786
// #define	swCardError           0x6787
// #define	swCardNotReset        0x6788
// #define	swKeyNotLoaded        0x6789
// #define	swPolyNotLoaded       0x678A
// #define	swBadResponseCRC      0x678B
// #define	swCardTimedOut        0x678C
// #define	swTermOutOfMemory     0x678D
// #define	swBadDesResponse      0x678E
// #define	swInvalidComPort      0x678F
// #define	swComPortNotSupported 0x6790
// #define	swWriteVerifyError    0x67F0
swCommandOK           = $9000;
swRetriesRemaining    = $63C0;
swEepromWriteError    = $6581;
swKeyNotFound         = $6611;
swPolyNotFound        = $6612;
swKeyTooShort         = $6613;
swKeyDisabled         = $6614;
swUnknownAlgorithm    = $6615;
swAlreadyEncrypting   = $66C0;
swNotEncrypting       = $66C1;
swBadCommandCRC       = $66C2;
swDesCheckError       = $66C3;
swLcLeError           = $6700;
swCommandTooLong      = $6781;
swInvalidState        = $6985;
swCardUnconfigured    = $6986;
swNewStateError       = $6987;
swP1P2Error           = $6A00;
swOutsideEeprom       = $6A02;
swDataNotFound        = $6A88;
swINSNotFound         = $6D00;
swCLANotFound         = $6E00;
swNoCardReader        = $6782;
swCardReaderError     = $6783;
swNoCardInReader      = $6784;
swCardPulled          = $6785;
swT1Error             = $6786;
swCardError           = $6787;
swCardNotReset        = $6788;
swKeyNotLoaded        = $6789;
swPolyNotLoaded       = $678A;
swBadResponseCRC      = $678B;
swCardTimedOut        = $678C;
swTermOutOfMemory     = $678D;
swBadDesResponse      = $678E;
swInvalidComPort      = $678F;
swComPortNotSupported = $6790;
swWriteVerifyError    = $67F0;



// #endif

// #ifdef ZCBCI_INCL_FE
// #define feInvalidDrive        1
// #define feBadFilename         2
// #define feBadFilenum          3
// #define feFileNotFound        4
// #define feFileNotOpen         5
// #define feOpenError           6
// #define feSeekError           7
// #define feReadError           8
// #define feWriteError          9
// #define feCloseError          10
// #define feInvalidMode         11
// #define feInvalidAccess       12
// #define feRenameError         13
// #define feAccessDenied        14
// #define feSharingViolation    15
// #define feFileAlreadyExists   16
// #define feNotDataFile         17
// #define feNotDirectory        18
// #define feDirNotEmpty         19
// #define feBadFileChain        20
// #define feFileOpen            21
// #define feNameTooLong         22
// #define feRecordTooLong       23
// #define feTooManyOpenFiles    24
// #define feTooManyCardFiles    25
// #define feCommsError          26
// #define feRemoteFile          27
// #define feNotRemoteFile       28
// #define feRecursiveRename     29
// #define feInvalidFromKeyboard 30
// #define feBadParameter        31
// #define feOutOfMemory         32
// #define feNoFileSystem        33
// #define feUnexpectedError     34
// #define feNotImplemented      35
// #define feTooManyCustomLocks  36

feInvalidDrive        = 1;
feBadFilename         = 2;
feBadFilenum          = 3;
feFileNotFound        = 4;
feFileNotOpen         = 5;
feOpenError           = 6;
feSeekError           = 7;
feReadError           = 8;
feWriteError          = 9;
feCloseError          =10;
feInvalidMode         =11;
feInvalidAccess       =12;
feRenameError         =13;
feAccessDenied        =14;
feSharingViolation    =15;
feFileAlreadyExists   =16;
feNotDataFile         =17;
feNotDirectory        =18;
feDirNotEmpty         =19;
feBadFileChain        =20;
feFileOpen            =21;
feNameTooLong         =22;
feRecordTooLong       =23;
feTooManyOpenFiles    =24;
feTooManyCardFiles    =25;
feCommsError          =26;
feRemoteFile          =27;
feNotRemoteFile       =28;
feRecursiveRename     =29;
feInvalidFromKeyboard =30;
feBadParameter        =31;
feOutOfMemory         =32;
feNoFileSystem        =33;
feUnexpectedError     =34;
feNotImplemented      =35;
feTooManyCustomLocks  =36;

 


// #endif

// #ifdef ZCBCI_INCL_FA
// #define faDirectory  0x0010
// #define faCardFile   0x0040
// #define faReadOnly   0x0001
// #define faHiddenFile 0x0002
// #define faSystemFile 0x0004
// #define faArchived   0x0020
// #define faNormal     0x0080
// #define faTemporary  0x0100

faDirectory            = $0010;
faCardFile             = $0040;
faReadOnly             = $0001;
faHiddenFile           = $0002;
faSystemFile           = $0004;
faArchived             = $0020;
faNormal               = $0080;
faTemporary            = $0100;
// #endif

// #ifdef ZCBCI_INCL_LI
// #define liAllowed   0
// #define liKeyed1    1
// #define liKeyed2    2
// #define liForbidden 3
// #define liUnlocked  1
// #define liLocked    2


liAllowed    = 0;
liKeyed1     = 1;
liKeyed2     = 2;
liForbidden  = 3;
liUnlocked   = 1;
liLocked     = 2;

// #endif

// /* linkage conventions */
// #define ZCBCILINK APIENTRY

{
/* function prototypes */
/******************************************************************************/
/* Function       : ZCBciAttach                                               */
/* Description    : Attach to basiccard                                       */
/*                  Note: First connect to card reader and card by            */
/*                        ZCCriConnect, then attach to BCI by using           */
/*                        ZCCRIREADER returned by ZCCriConnect.               */
/* Parameter      : (in) reader  reader returned by ZCCriConnect              */
/*                  (out) *pCard handle to attached context                   */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/******************************************************************************/
/* History        : 19990223 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciAttach(ZCCRIREADER reader, PZCBCICARD pCard);
}
function ZCBciAttach(reader:ZCCRIREADER;pCard:PZCBCICARD):ZCBCIRET;
                                                   stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciDetach                                               */
/* Description    : Detach from basiccard (close context)                     */
/* Parameter      : (in) card handle to attached context                      */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/******************************************************************************/
/* History        : 19990223 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciDetach(ZCBCICARD card);
}
function ZCBciDetach(card:ZCBCICARD):ZCBCIRET;stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciSetKey                                               */
/* Description    : Set encryption key (must match card declared key)         */
/* Parameter      : (in) card handle to attached context                      */
/*                  (in)  keynum number of key (same as declared in card      */
/*                               file                                         */
/*                  (in)  *pKey  key bytes (same key and byte order as        */
/*                               declared in card basic file                  */
/*                  (in)  cbKey  sizeof key (8 or 16 bytes)                   */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/******************************************************************************/
/* History        : 19990224 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciSetKey(ZCBCICARD card,
				    BYTE keynum, BYTE *pKey, BYTE cbKey);

}
function ZCBciSetKey(card:ZCBCICARD;keynum:Byte;pKey:PBYTE;cbKey:Byte):ZCBCIRET;
                                                   stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciSetPoly                                              */
/* Description    : Set encryption polynom (must match card declared polynom) */
/* Parameter      : (in) card handle to attached context                      */
/*                  (in)  polynomA first polynom maybe 0 if no SG_LFSR will   */
/*                                 used (otherwise same as ...)               */
/*                  (in)  polynomS second polynom maybe 0 if no SG_LFSR will  */
/*                                 used (otherwise same as ...)               */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/******************************************************************************/
/* History        : 19990224 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciSetPoly(ZCBCICARD card,
					     DWORD polynomA, DWORD polynomS);
}

function ZCBciSetPoly(card:ZCBCICARD;polynomA:DWORD;polynomS:DWORD):ZCBCIRET;
                                                   stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciReadKeyFile                                          */
/* Description    : Load encryption keys from file (as generated by keygen)   */
/* Parameter      : (in) card handle to attached context                      */
/*                  (in) pszFile name of key file                             */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_INVALID_FILE invalid key file                 */
/******************************************************************************/
/* History        : 19990304 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciReadKeyFile(ZCBCICARD card, CHAR *pszFile);
}

function ZCBciReadKeyFile(card:ZCBCICARD;pszFile:PChar):ZCBCIRET;
                                                   stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciTransaction                                          */
/* Description    : Do low level transaction                                  */
/* Parameter      : (in) card handle to attached context                      */
/*                  (in) Cla class byte                                       */
/*                  (in) Ins instruction byte                                 */
/*                  (in/out) pData pointer to array of BasicCard parameters   */
/*                  (in) bdataCount number of BasicCard parameters            */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_OVERFLOW  to much data                        */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                  ZCBCI_ERROR_MISSING_PARM one or more return parameter is  */
/*                                           missing                          */
/******************************************************************************/
/* History        : 19990223 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciTransaction(ZCBCICARD card, BYTE Cla, BYTE Ins,
					PZCBCIPARM pData, BYTE bDataCount,
							WORD *pSW1SW2);

}
function ZCBciTransaction(card:ZCBCICARD;cla:Byte;Ins:Byte;pData:PZCBCIPARM;
                          bDataCount:Byte;pSW1SW2:PWORD):ZCBCIRET;
                                                   stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciTransaction2                                         */
/* Description    : transaction for special cases not supported by            */
/*                  ZCBciTransaction                                          */
/* Parameter      : (in) card handle to attached context                      */
/*                  (in) Cla class byte                                       */
/*                  (in) Ins instruction byte                                 */
/*                  (in) P1  parameter 1                                      */
/*                  (in) P2  parameter 2                                      */
/*                  (in) Lc  Lc (0..255) or ZCBCI_DEFAULT_LC                  */
/*                  (in) Le  Le (0..255) ZCBCI_DISABLE_LE or ZCBCI_DEFAULT_LE */
/*                  (in/out) pData pointer to array of BasicCard parameters   */
/*                  (in) bdataCount number of BasicCard parameters            */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_OVERFLOW  to much data                        */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                  ZCBCI_ERROR_MISSING_PARM one or more return parameter is  */
/*                                           missing                          */
/******************************************************************************/
/* History        : 19990223 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciTransaction2(ZCBCICARD card, BYTE Cla, BYTE Ins,
			    		BYTE P1, BYTE P2, WORD Lc, WORD Le,
			    		PZCBCIPARM pData, BYTE bDataCount,
			    				WORD *pSW1SW2);

}

function ZCBciTransaction2(card:ZCBCICARD;Cla,Ins,P1,P2:Byte;Lc,Le:Word;
                       pData:PZCBCIPARM;bDataCount:Byte;pSW1SW2:PWORD):ZCBCIRET;
                                                   stdcall;external 'ZCBCI.DLL';



//-----------------------------------------------------------------------------
//#ifdef ZCBCI_COMPACT
//-----------------------------------------------------------------------------
//* Compact BasicCard */
{
/******************************************************************************/
/* Function       : ZCBciGetState                                             */
/* Description    : BasicCard GET STATE command (Cla C0, Ins 00)              */
/*                  return card state (ZCBCI_STATE_NEW, ZCBCI_STATE_LOAD,     */
/*                  ZCBCI_STATE_TEST or ZCBCI_STATE_RUN)                      */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pState  card state                                 */
/*                  (out) *pVersion BasicCard version                         */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_OVERFLOW  to much data                        */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                  ZCBCI_ERROR_MISSING_PARM one or more return parameter is  */
/*                                           missing                          */
/******************************************************************************/
/* History        : 19990224 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciGetState(ZCBCICARD card, WORD *pSW1SW2,
						 BYTE *pState, WORD *pVersion);

}
function ZCBciGetState(card:ZCBCICARD;pSW1SW2:PWORD;pState:PBYTE;pVersion:PWORD)
                                         :ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciEepromSize                                           */
/* Description    : BasicCard EEPROM SIZE command (Cla C0, Ins 02)            */
/*                  return start and length of card eeprom                    */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pStart  start of card eeprom                       */
/*                  (out) *pLength length of card eeprom                      */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_OVERFLOW  to much data                        */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                  ZCBCI_ERROR_MISSING_PARM one or more return parameter is  */
/*                                           missing                          */
/******************************************************************************/
/* History        : 19990224 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciEepromSize(ZCBCICARD card, WORD *pSW1SW2,
						   WORD *pStart, WORD *pLength);
}
function ZCBciEepromSize(card:ZCBCICARD;pSW1SW2,pStart,pLength:PWORD):ZCBCIRET;
                                                   stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCClearEeprom                                             */
/* Description    : BasicCard CLEAR EEPROM command (Cla C0, Ins 04)           */
/*                  clear (set to FF) length bytes of eeprom starting at start*/
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (in)  start  start of card eeprom to clear                */
/*                  (in)  length length of card eeprom to clear               */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_OVERFLOW  to much data                        */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/******************************************************************************/
/* History        : 19990224 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciClearEeprom(ZCBCICARD card, WORD *pSW1SW2,
						   WORD start, WORD length);
}

function ZCBciClearEeprom(card:ZCBCICARD;pSW1SW2:PWORD;pStart,pLength:WORD):ZCBCIRET;
                                                   stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCWriteEeprom                                             */
/* Description    : BasicCard WRITE EEPROM command (Cla C0, Ins 06)           */
/*                  write cbData bytes to eeprom starting at start            */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (in)  start  start of card eeprom to clear                */
/*                  (in)  pData  data to write                                */
/*                  (in)  cbData length of data to write                      */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_OVERFLOW  to much data                        */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/******************************************************************************/
/* History        : 19990224 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciWriteEeprom(ZCBCICARD card, WORD *pSW1SW2,
				    WORD start, BYTE *pData, BYTE cbData);

}
function ZCBciWriteEeprom(card:ZCBCICARD;pSW1SW2:PWORD;start:WORD;pData:PBYTE;
                          cbData:Byte):ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCReadEeprom                                              */
/* Description    : BasicCard READ EEPROM command (Cla C0, Ins 08)            */
/*                  read cbData bytes from eeprom starting at start           */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (in)  start  start of card eeprom to clear                */
/*                  (out) *pData  data read                                   */
/*                  (in)  cbData length of data to read                       */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_OVERFLOW  to much data                        */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                  ZCBCI_ERROR_MISSING_PARM one or more return parameter is  */
/*                                           missing                          */
/******************************************************************************/
/* History        : 19990224 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciReadEeprom(ZCBCICARD card, WORD *pSW1SW2,
				    WORD start, BYTE *pData, BYTE cbData);

}
function ZCBciReadEeprom(card:ZCBCICARD;pSW1SW2:PWORD;start:WORD;pData:PBYTE;
                         cbData:Byte):ZCBCIRET;stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciEepromCRC                                            */
/* Description    : BasicCard EEPROM CRC command (Cla C0, Ins 0A)             */
/*                  calculate and return eeprom crc                           */
/*                  Note: Calling ZCBciEepromCRC on empty (no program loaded) */
/*                        Enhanced BasicCard will destroy card.               */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (in)  start  start address                                */
/*                  (in)  length to verify                                    */
/*                  (out) *pCRC  resulting crc                                */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_OVERFLOW  to much data                        */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                  ZCBCI_ERROR_MISSING_PARM one or more return parameter is  */
/*                                           missing                          */
/******************************************************************************/
/* History        : 19990224 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciEepromCRC(ZCBCICARD card, WORD *pSW1SW2,
					  WORD start, WORD length, WORD *pCRC);

}
function ZCBciEepromCRC(card:ZCBCICARD;pSW1SW2:PWORD;pStart,pLength:WORD;
                              pCRC:PWORD):ZCBCIRET;stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciSetState                                             */
/* Description    : BasicCard SET STATE command (Cla C0, Ins 0C)              */
/*                  set card state (ZCBCI_STATE_LOAD,                         */
/*                  ZCBCI_STATE_TEST or ZCBCI_STATE_RUN)                      */
/*                  Note: You need to reset card (ZCCriReconnect) before doing*/
/*                        any further action on this card.                    */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (in)  state  new card state                               */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_OVERFLOW  to much data                        */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/******************************************************************************/
/* History        : 19990224 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciSetState(ZCBCICARD card, WORD *pSW1SW2,
								 BYTE state);
}
function ZCBciSetState(card:ZCBCICARD;pSW1SW2:PWORD; state : byte):ZCBCIRET;
                                                  stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciGetApplicationID                                     */
/* Description    : BasicCard GET APPLICATION ID command (Cla C0, Ins 0E)     */
/*                  get application id                                        */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pszID  application id                              */
/*                  (in)  cbID  size of buffer to hold id                     */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_OVERFLOW  to much data                        */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                  ZCBCI_ERROR_MISSING_PARM one or more return parameter is  */
/*                                           missing                          */
/******************************************************************************/
/* History        : 19990224 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciGetApplicationID(ZCBCICARD card, WORD *pSW1SW2,
					         CHAR *pszID, BYTE cbID);
}

function ZCBciGetApplicationID(card:ZCBCICARD;pSW1SW2:PWORD;pszID:PBYTE;
                               cbID:Byte):ZCBCIRET;stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciStartEncryption                                      */
/* Description    : BasicCard START ENCRYPTION command (Cla C0, Ins 10)       */
/*                  start transparent encryption                              */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (in)  algo  algorithm to use either ZCBCI_SG_LFSR,        */
/*                              ZCBCI_SG_LFSR_CRC, ZCBCI_DES or ZCBCI_3DES    */
/*                  (in)  key   key to use (see ZCBciSetKey also)             */
/*                  (in)  random input random used by encryption as part of IV*/
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_OVERFLOW  to much data                        */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                  ZCBCI_ERROR_MISSING_PARM one or more return parameter is  */
/*                                           missing                          */
/******************************************************************************/
/* History        : 19990224 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciStartEncryption(ZCBCICARD card, WORD *pSW1SW2,
				        BYTE algo, BYTE key, DWORD random);
}
function ZCBciStartEncryption(card:ZCBCICARD;pSW1SW2:PWORD; algo,key:Byte;
                              random:DWORD):ZCBCIRET;stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciEndEncryption                                        */
/* Description    : BasicCard END ENCRYPTION command (Cla C0, Ins 12)         */
/*                  stop transparent encryption                               */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_OVERFLOW  to much data                        */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                  ZCBCI_ERROR_MISSING_PARM one or more return parameter is  */
/*                                           missing                          */
/******************************************************************************/
/* History        : 19990224 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciEndEncryption(ZCBCICARD card, WORD *pSW1SW2);
}

function ZCBciEndEncryption(card:ZCBCICARD;pSW1SW2:PWORD):ZCBCIRET;
                                                  stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciEcho                                                 */
/* Description    : BasicCard ECHO command (Cla C0, Ins 04)                   */
/*                  echo data (for testing)                                   */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (in)  inc increment value                                 */
/*                  (in/out) *pszEcho '\0' terminated echo string             */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_OVERFLOW  to much data                        */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                  ZCBCI_ERROR_MISSING_PARM one or more return parameter is  */
/*                                           missing                          */
/******************************************************************************/
/* History        : 19990224 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciEcho(ZCBCICARD card, WORD *pSW1SW2,
						     BYTE inc, CHAR *pszEcho);
}

function ZCBciEcho(card:ZCBCICARD;pSW1SW2:PWORD; inc:Byte;
                           pszEcho:PBYTE):ZCBCIRET;stdcall;external 'ZCBCI.DLL';




{
#ifdef ZCBCI_ENHANCED
* Enhanced BasicCard (only) */
/******************************************************************************/
/* Function       : ZCBciMkDir                                                */
/* Description    : Make directory on card                                    */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) pszPath dircetory to create. Path may be relative    */
/*                               to current directory or absolut (starting    */
/*                               with "\"                                     */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/

ZCBCIRET ZCBCILINK ZCBciMkDir(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
							  CHAR *pszPath);
}

function ZCBciMkDir(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
		  pszPath:PBYTE) :ZCBCIRET;stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciRmDir                                                */
/* Description    : Remove directory on card                                  */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) pszPath dircetory to remove. Path may be relative    */
/*                               to current directory or absolut (starting    */
/*                               with "\"                                     */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/

ZCBCIRET ZCBCILINK ZCBciRmDir(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
							  CHAR *pszPath);
}
function ZCBciRmDir(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
			  pszPath:PBYTE): ZCBCIRET;stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciChDir                                                */
/* Description    : Change current directory on card                          */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) pszPath dircetory to change. Path may be relative    */
/*                               to current directory or absolut (starting    */
/*                               with "\"                                     */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/

ZCBCIRET ZCBCILINK ZCBciChDir(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
							  CHAR *pszPath);
}

function ZCBciChDir(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE; pszPath:PBYTE)
                                    : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciCurDir                                               */
/* Description    : Return current directory                                  */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (out) pszPath current directory                           */
/*                  (in)  cbPath sizeof buffer pszPath                        */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/*                  ZCBCI_ERROR_OVERFLOW  directory name exceeds buffer size  */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/

ZCBCIRET ZCBCILINK ZCBciCurDir(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
							   CHAR *pszPath, BYTE cbPath);
}
function ZCBciCurDir(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE; pszPath:PBYTE;
                                     cbPath:BYTE): ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciRename                                               */
/* Description    : Rename or move a file or directory                        */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) pszOldPath current file/directory name               */
/*                  (in) pszNewPath new file/directory name                   */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/

ZCBCIRET ZCBCILINK ZCBciRename(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
				       	   CHAR *pszOldPath, CHAR *pszNewPath);
}
function ZCBciRename(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                     pszOldPath:PBYTE; pszNewPath:PBYTE):
                     ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciDirCount                                             */
/* Description    : Count files on card matching filespec                     */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) pszFileSpec filespec to search for                   */
/*                  (out) *pCount number of files match                       */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciDirCount(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
					     CHAR *pszFileSpec, WORD *pCount);
}
function ZCBciDirCount(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                       pszFileSpec:PBYTE; pCount:PWORD)
                       : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciDirFile                                              */
/* Description    : Return file on card matching filespec and number          */
/*                  ZCBciDirCount must be called before with same filespec    */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) pszFileSpec filespec to search for                   */
/*                  (in) num number of file to return (1<=num<=count)         */
/*                  (out) *pszFile name of matching file                      */
/*                  (in) cbFile size of buffer pszFile                        */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/*                  ZCBCI_ERROR_OVERFLOW  filename exceeds buffer size        */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciDirFile(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
						    CHAR *pszFileSpec, WORD num,
							CHAR *pszFile, BYTE cbFile);
}
function ZCBciDirFile(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                      pszFileSpec:PBYTE; num:WORD; pszFile:PBYTE; cbFile:BYTE)
                      : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciGetAttr                                              */
/* Description    : Get file or directory attribute                           */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) pszPath dircetory or file to change. Path may be     */
/*                               relative to current directory or absolut     */
/*                               (starting with "\")                          */
/*                  (out) *pAttrib returned attributes (see fa... for         */
/*                                 attributes)                                */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciGetAttr(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
				     		    CHAR *pszPath, WORD *pAttrib);
}
function ZCBciGetAttr(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                      pszPath:PBYTE; pAttrib:PWORD)
                      : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciEraseFile                                            */
/* Description    : Erase file                                                */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) pszPath file to erase                                */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciEraseFile(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
							      CHAR *pszPath);
}
function ZCBciEraseFile(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                        pszPath:PBYTE): ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciOpenFile                                             */
/* Description    : Open file on BasicCard                                    */
/*                  Note: There is a difference in using ZCBCiFileWriteUser   */
/*                        and ZCBciFilePut or ZCBciFilePutPos. Write functions*/
/*                        do not result in same binary file data as done by   */
/*                        put functions. You must use put/get functions if    */
/*                        file open mode is binary (ZCBCI_MODE_BINARY) or     */
/*                        random (ZCBCI_MODE_RANDOM), and you must use        */
/*                        read/write functions otherwise. See BasicCard       */
/*                        reference manual for more details.                  */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) pszPath file to open                                 */
/*                  (in) mode any valid combination of ZCBCI_MODE_..,         */
/*                       ZCBCI_ACCESS_.. and ZCBCI_SHARE_.. use '|' to concat */
/*                       values                                               */
/*                       Note: do not conncat ZCBCI_SHARE_LOCKREAD and        */
/*                             ZCBCI_SHARE_LOCKWRITE by '|' use               */
/*                             ZCBCI_SHARE_LOCKREADWRITE instead              */
/*                  (in) recordlen record/block size used by file             */
/*                  (out) *pFileNum handle to open file use for fileio        */
/*                        on this open file                                   */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciOpenFile(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
			      CHAR *pszPath, BYTE mode, WORD recordlen,
			      	 WORD *pFileNum);
}
function ZCBciOpenFile(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                       pszPath:PBYTE; mode:BYTE; recordlen:WORD;
                       pFileNum:PWORD)
                       : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciCloseFile                                            */
/* Description    : Close file on BasicCard                                   */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file to close                                */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciCloseFile(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
							      WORD FileNum);
}
function ZCBciCloseFile(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                        FileNum:WORD): ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciCloseAllFiles                                        */
/* Description    : Close all files on BasicCard                              */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciCloseAllFiles(ZCBCICARD card, WORD *pSW1SW2,
							     BYTE *pFileErr);
}
function ZCBciCloseAllFiles(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE)
                                            : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFileLength                                           */
/* Description    : Return file length of open file                           */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (out) *pFileLength length of file                         */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileLength(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
					        WORD FileNum, DWORD *pFileLength);
}
function ZCBciFileLength(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                           FileNum:WORD; pFileLength:PDWORD)
                           : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciGetFilepos                                           */
/* Description    : Get file position                                         */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (out) *pFilePos  position of file pointer                 */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciGetFilepos(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
					       WORD FileNum, DWORD *pFilePos);
}
function ZCBciGetFilepos(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                         FileNum:WORD; pFilePos:PDWORD)
                         : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciSetFilepos                                           */
/* Description    : Set file position                                         */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (in) FilePos  position of file pointer                    */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciSetFilepos(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
				       	       WORD FileNum, DWORD FilePos);
}
function ZCBciSetFilepos(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                         FileNum:WORD; FilePos:DWORD)
                         : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciQueryEof                                             */
/* Description    : Query if end of file is reached                           */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (out) *pfEof  TRUE if EOF otherwise FALSE                 */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciQueryEof(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
						     WORD FileNum, BOOL *pfEof);
}
function ZCBciQueryEof(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                       FileNum:WORD; pfEof:PBOOL)
                       : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFileGet                                              */
/* Description    : Get content of open file at current file position         */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (out) *pData  data read from file                         */
/*                  (in)  cbData  number of data bytes requested              */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/*                  ZCBCI_ERROR_MISSING_PARM not enough data received         */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileGet(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
					    WORD FileNum, BYTE *pData, BYTE cbData);
}
function ZCBciFileGet(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                      FileNum:WORD; pData:PBYTE; cbData:BYTE)
                      : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFileGetPos                                           */
/* Description    : Get content of open file at specified file position       */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (in) pos  position to read from                           */
/*                  (out) *pData  data read from file                         */
/*                  (in)  cbData  number of data bytes requested              */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/*                  ZCBCI_ERROR_MISSING_PARM not enough data received         */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileGetPos(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
 						       WORD FileNum, DWORD pos,
 							   BYTE *pData, BYTE cbData);
}
function ZCBciFileGetPos(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                         FileNum:WORD; pos:DWORD; pData:PBYTE; cbData:BYTE)
                         : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFilePut                                              */
/* Description    : Put content of pData to open file at current file position*/
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (out) *pData  data to write to file                       */
/*                  (in)  cbData  number of data bytes to write               */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFilePut(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
				    WORD FileNum, BYTE *pData, BYTE cbData);
}
function ZCBciFilePut(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                      FileNum:WORD; pData:PBYTE; cbData:BYTE)
                      : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFilePutPos                                           */
/* Description    : Put content of pData to open file at specified file       */
/*                  position                                                  */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (in) pos  position to write to                            */
/*                  (out) *pData  data to write to file                       */
/*                  (in)  cbData  number of data bytes to write               */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFilePutPos(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
						       WORD FileNum, DWORD pos,
						   BYTE *pData, BYTE cbData);
}
function ZCBciFilePutPos(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                         FileNum:WORD; pos:DWORD; pData:PBYTE; cbData:BYTE)
                         : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFileRead                                             */
/* Description    : Read the content of file at current position to pData     */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (out) *pData  data read from file                         */
/*                  (in)  cbData  number of data bytes to read                */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990325 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileRead(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
				     WORD FileNum, BYTE *pData, BYTE cbData);
}
function ZCBciFileRead(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                       FileNum:WORD; pData:PBYTE; cbData:BYTE)
                      : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFileReadLong                                         */
/* Description    : Read long value from file at current position to plVar    */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (out) *plVar long value read from file                    */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990325 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileReadLong(ZCBCICARD card, WORD *pSW1SW2,
					 BYTE *pFileErr, WORD FileNum,
							 LONG *plVar);
}
function ZCBciFileReadLong(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                           FileNum:WORD;  plVar:PLONG)
                      : ZCBCIRET;stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciFileReadSingle                                       */
/* Description    : Read single/float value from file at current position to  */
/*                  pflVar                                                    */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (out) *pflVar float value read from file                  */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990325 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileReadSingle(ZCBCICARD card, WORD *pSW1SW2, 
					   BYTE *pFileErr, WORD FileNum,
					   float *pflVar);
}
function ZCBciFileReadSingle(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                             FileNum:WORD; pflVar:PSINGLE)
                             : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFileReadString                                       */
/* Description    : Read string from file at current position to pszVar       */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (out) *pszVar  string read from file                      */
/*                  (in)  cbVar  size of string buffer                        */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/*                  ZCBCI_ERROR_OVERFLOW  string exceeds buffer size          */
/******************************************************************************/
/* History        : 19990325 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileReadString(ZCBCICARD card, WORD *pSW1SW2,
						   BYTE *pFileErr, WORD FileNum,
						   CHAR *pszVar, BYTE cbVar);
}
function ZCBciFileReadString(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                             FileNum:WORD; pszVar:PBYTE; cbVar:BYTE)
                             : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFileReadUser                                         */
/* Description    : Read user type data from file at current position to pData*/
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (out) *pData  data read from file                         */
/*                  (in/out)  *pcbData length of data buffer/bytes read       */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/*                  ZCBCI_ERROR_OVERFLOW  data exceeds buffer size            */
/******************************************************************************/
/* History        : 19990325 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileReadUser(ZCBCICARD card, WORD *pSW1SW2,
					 BYTE *pFileErr, WORD FileNum,
					 BYTE *pData, BYTE *pcbData);
}
function ZCBciFileReadUser(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                           FileNum:WORD; pData:PBYTE; pcbData:PBYTE)
                      : ZCBCIRET;stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciFileReadUser2                                        */
/* Description    : Read block from file at current position to pData         */
/*                  Note: In opposition to ZCBciFileReadUser cbData must match*/
/*                        length of data object stored in file.               */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (out) *pData  block read from file                        */
/*                  (in)  cbData  block length                                */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990325 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileReadUser2(ZCBCICARD card, WORD *pSW1SW2,
					  BYTE *pFileErr, WORD FileNum,
					  BYTE *pData, BYTE cbData);
}

function ZCBciFileReadUser2(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                      FileNum:WORD; pData:PBYTE; cbData:BYTE)
                      : ZCBCIRET;stdcall;external 'ZCBCI.DLL';

{
/******************************************************************************/
/* Function       : ZCBciFileReadLine                                         */
/* Description    : Read line from file at current position to pszLine        */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (out) *pszLine  line read from file                       */
/*                  (in)  cbLine  size of buffer pszLine                      */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/*                  ZCBCI_ERROR_OVERFLOW buffer pszLine to small              */
/******************************************************************************/
/* History        : 19990407 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileReadLine(ZCBCICARD card, WORD *pSW1SW2,
					 BYTE *pFileErr, WORD FileNum,
					 CHAR *pszLine, BYTE cbLine);
}
function ZCBciFileReadLine(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                           FileNum:WORD; pszLine:PBYTE; cbLine:BYTE)
                           : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFileWriteLong                                        */
/* Description    : Write long value at current position to file              */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (in) lVal  long value to write                            */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990407 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileWriteLong(ZCBCICARD card, WORD *pSW1SW2,
					  BYTE *pFileErr, WORD FileNum,
					  LONG lVal);
}
function ZCBciFileWriteLong(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                             FileNum:WORD; lVal:LONG)
                             : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFileWriteSingle                                      */
/* Description    : Write float (single) value at current position to file    */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (in) flVal  float (single) value to write                 */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990413 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileWriteSingle(ZCBCICARD card, WORD *pSW1SW2,
					    BYTE *pFileErr, WORD FileNum,
					    float flVal);
}
function ZCBciFileWriteSingle(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                              FileNum:WORD; flVal:SINGLE)
                              : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFileWriteUser                                        */
/* Description    : Write user type data at current position to file          */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (in) *pbData  data to write                               */
/*                  (in) cbData  length of data to write                      */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990413 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileWriteUser(ZCBCICARD card, WORD *pSW1SW2,
					  BYTE *pFileErr, WORD FileNum,
					  BYTE *pData, BYTE cbData);
}
function ZCBciFileWriteUser(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                            FileNum:WORD; pData:PBYTE; cbData:BYTE)
                            : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFileWriteString                                      */
/* Description    : Write string data at current position to file             */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (in) *pszVal  string to write                             */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990413 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileWriteString(ZCBCICARD card, WORD *pSW1SW2,
					    BYTE *pFileErr, WORD FileNum,
					    CHAR *pszVal);
}
function ZCBciFileWriteString(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                              FileNum:WORD; pszVal:PBYTE)
                      : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFileWrite                                            */
/* Description    : Write data at current position to file.                   */
/*                  In difference to ZCBciFileWriteUser data is not prefixed  */
/*                  with type byte, before written to file.                   */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (in) *pbData  data to write                               */
/*                  (in) cbData  length of data to write                      */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990413 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFileWrite(ZCBCICARD card, WORD *pSW1SW2,
					  BYTE *pFileErr, WORD FileNum,
					  BYTE *pData, BYTE cbData);
}
function ZCBciFileWrite(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                        FileNum:WORD; pData:PBYTE; cbData:BYTE)
                      : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciFilePrint                                            */
/* Description    : Print string at current position to file.                 */
/*                  This function just calls ZCBciFileWrite                   */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) FileNum file number returned by ZCBciOpenFile        */
/*                  (in) *pszVal  string to write                             */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990413 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciFilePrint(ZCBCICARD card, WORD *pSW1SW2,
					  BYTE *pFileErr, WORD FileNum,
					  CHAR *pszVal);
}
function ZCBciFilePrint(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                        FileNum:WORD; pszVal:PBYTE)
                      : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciGetLockInfo                                          */
/* Description    : Get lock information of file or directory                 */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) *pszPath file/directory to query                     */
/*                  (out) *pInfo  lock information of file or directory       */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/*                  ZCBCI_ERROR_MISSING_PARM not enough data received         */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciGetLockInfo(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
				        CHAR *pszPath, PZCBCILOCKINFO pInfo);
}
function ZCBciGetLockInfo(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                           pszPath:PBYTE; pInfo:PZCBCILOCKINFO)
                           : ZCBCIRET;stdcall;external 'ZCBCI.DLL';
{
/******************************************************************************/
/* Function       : ZCBciSetFileLock                                          */
/* Description    : Set lock information of file or directory                 */
/* Parameter      : (in) card handle to attached context                      */
/*                  (out) *pSW1SW2 card return value SW1 SW2                  */
/*                  (out) *pFileErr file error as returned by card            */
/*                  (in) *pszPath file/directory to change                    */
/*                  (in) type lock type ZCBCI_LOCK_..                         */
/*                  (in) fLock TRUE lock file, FALSE unlock file              */
/*                  (in) KeyCount number of access keys (0..2)                */
/*                  (in) Key1 number of first key (ignored if KeyCount<1)     */
/*                  (in) Key2 number of second key (ignored if KeyCount<2)    */
/* Returnvalue    : ZCBCI_NOERROR    no error                                 */
/*                  ZCBCI_ERROR_PARM invalid parameter pCard                  */
/*                  ZCBCI_ERROR_TRANS_FAILED transaction failed (SW1SW2       */
/*                                           differs from 0x9000 or 0x61XX    */
/*                                           or file error occured (*pFileErr */
/*                                           !=0)                             */
/******************************************************************************/
/* History        : 19990317 MP initial version                               */
/******************************************************************************/
ZCBCIRET ZCBCILINK ZCBciSetFileLock(ZCBCICARD card, WORD *pSW1SW2, BYTE *pFileErr,
			        CHAR *pszPath, ZCBCILOCK type, BOOL fLock,
				BYTE KeyCount, BYTE Key1, BYTE Key2);

#endif

#ifdef __cplusplus

#endif

#endif
}

function ZCBciSetFileLock(card:ZCBCICARD; pSW1SW2:PWORD; pFileErr:PBYTE;
                          pszPath:PBYTE; typelock:ZCBCILOCK; fLock:BOOL;
                          KeyCount:BYTE; Key1:BYTE; Key2:BYTE)
                          : ZCBCIRET;stdcall;external 'ZCBCI.DLL';




// function leer():ZCBCIRET;stdcall;external 'ZCBCI.DLL';
// function leer():ZCBCIRET;stdcall;external 'ZCBCI.DLL';
// function leer():ZCBCIRET;stdcall;external 'ZCBCI.DLL';
// function leer():ZCBCIRET;stdcall;external 'ZCBCI.DLL';
// function leer():ZCBCIRET;stdcall;external 'ZCBCI.DLL';
// function leer():ZCBCIRET;stdcall;external 'ZCBCI.DLL';
// function leer():ZCBCIRET;stdcall;external 'ZCBCI.DLL';






//=============================================================================
//  Includefile zccrypt.h
//=============================================================================



{
/******************************************************************************/
/* Copyright      : ZeitControl cardsystems GmbH 2000                         */
/* Author         : Michael Petig                                             */
/*                  based on crypto functions from Tony Guilfoyle             */
/******************************************************************************/
/* Project        : ZeitControl Crypto API                                    */
/* Description    : Crypto support API including ECC, DES and SHA             */
/* History        : 20000128 MP initial version                               */
/*                  20000823 RK Delphi version                                */
/******************************************************************************/

#ifndef __ZCCRYPT_H__
#define __ZCCRYPT_H__

#ifdef __cplusplus
extern "C" {
#endif
}
{
/* API version */
#define ZCCRYPT_VER 0x100
#define ZCCRYPT_VER_1_0
}
Const
        ZCCRYPT_VER=$100;

{
/* linkage conventions */
#define ZCCRYPTLINK APIENTRY
}


{/* error codes */
#define ZCCRYPT_NOERROR                0UL}
        ZCCRYPT_NOERROR =              0;
{#define ZCCRYPT_ERROR_BASE             0x03000000UL}
        ZCCRYPT_ERROR_BASE  =          $3000000;
{#define ZCCRYPT_ERROR_PARM             (ZCCRYPT_ERROR_BASE + 0x0000UL)}
        ZCCRYPT_ERROR_PARM  =          ZCCRYPT_ERROR_BASE + $0;
{#define ZCCRYPT_ERROR_MISC             (ZCCRYPT_ERROR_BASE + 0x0001UL)}
        ZCCRYPT_ERROR_MISC  =          ZCCRYPT_ERROR_BASE + $1;
{#define ZCCRYPT_ERROR_MEM              (ZCCRYPT_ERROR_BASE + 0x0002UL)}
        ZCCRYPT_ERROR_MEM   =          ZCCRYPT_ERROR_BASE + $2;
{#define ZCCRYPT_ERROR_NOTALLOWED       (ZCCRYPT_ERROR_BASE + 0x0003UL)}
        ZCCRYPT_ERROR_NOTALLOWED =     ZCCRYPT_ERROR_BASE + $3;
{#define ZCCRYPT_ERROR_MISSINGPARM      (ZCCRYPT_ERROR_BASE + 0x0004UL)}
        ZCCRYPT_ERROR_MISSINGPARM =    ZCCRYPT_ERROR_BASE + $4;
{/* special error codes EC161 */}
{#define ZCCRYPT_ERROR_EC161_BASE          (ZCCRYPT_ERROR_BASE + 0x1000UL)}
        ZCCRYPT_ERROR_EC161_BASE =         ZCCRYPT_ERROR_BASE + $1000;
{#define ZCCRYPT_ERROR_EC161_BADPARAMS     (ZCCRYPT_ERROR_EC161_BASE + 0x0000UL)}
        ZCCRYPT_ERROR_EC161_BADPARAMS =    ZCCRYPT_ERROR_EC161_BASE + $0;
{#define ZCCRYPT_ERROR_EC161_BADSIGNATURE  (ZCCRYPT_ERROR_EC161_BASE + 0x00001L)}
        ZCCRYPT_ERROR_EC161_BADSIGNATURE = ZCCRYPT_ERROR_EC161_BASE + $1;
{/* special error codes random */}
{#define ZCCRYPT_ERROR_RND_BASE         (ZCCRYPT_ERROR_BASE + 0x2000UL)}
        ZCCRYPT_ERROR_RND_BASE =           ZCCRYPT_ERROR_BASE + $2000;
{#define ZCCRYPT_ERROR_RND_NOTINIT      (ZCCRYPT_ERROR_RND_BASE + 0x0000UL)}
        ZCCRYPT_ERROR_RND_NOTINIT =        ZCCRYPT_ERROR_RND_BASE + $0;
{#define ZCCRYPT_ERROR_RND_ALREADYINIT  (ZCCRYPT_ERROR_RND_BASE + 0x0001UL)}
        ZCCRYPT_ERROR_RND_ALREADYINIT =    ZCCRYPT_ERROR_RND_BASE + $1;




// /* type definitions */
//#pragma pack(1)
type
// /* API return type */
//typedef DWORD ZCCRYPTRET;
        ZCCRYPTRET =  DWORD;
//typedef ZCCRYPTRET *PZCCRYPTRET;
        PZCCRYPTRET = ^DWORD;
// /* DES crypt context */
//typedef void *ZCCRYPT_CONTEXT_DES;
        ZCCRYPT_CONTEXT_DES = Pointer;
//typedef ZCCRYPT_CONTEXT_DES *PZCCRYPT_CONTEXT_DES;
        PZCCRYPT_CONTEXT_DES = ^Pointer;
// /* DES certificate context */
//typedef void *ZCCRYPT_CONTEXT_DES_CERT;
        ZCCRYPT_CONTEXT_DES_CERT = Pointer;
//typedef ZCCRYPT_CONTEXT_DES_CERT *PZCCRYPT_CONTEXT_DES_CERT;
        PZCCRYPT_CONTEXT_DES_CERT = ^Pointer;
// /* SHA context */
//typedef void *ZCCRYPT_CONTEXT_SHA;
         ZCCRYPT_CONTEXT_SHA = Pointer;
//typedef ZCCRYPT_CONTEXT_SHA *PZCCRYPT_CONTEXT_SHA;
         PZCCRYPT_CONTEXT_SHA = ^Pointer;
// /* encryption algorithm enum */
//typedef enum _ZCCRYPT_ALGO {
//    ZCCRYPT_ALGO_DES=0x21,
//    ZCCRYPT_ALGO_3DES=0x22,
//    ZCCRYPT_ALGO_DUMMY=0x7FFFFFFF  /* force enum to use 32 bit values */
//} ZCCRYPT_ALGO;
type  ZCCRYPT_ALGO = LongInt;
Const ZCCRYPT_ALGO_DES = $21;
      ZCCRYPT_ALGO_3DES = $22;

//typedef ZCCRYPT_ALGO *PZCCRYPT_ALGO;
type  PZCCRYPT_ALGO = ^LongInt;

// /* encryption mode enum */
//typedef enum _ZCCRYPT_MODE {
//    ZCCRYPT_MODE_ECB=1,
//    ZCCRYPT_MODE_CBC=2,
//#ifdef 	ALL_MODES
//	/* use on you own risk, this modes are not verified and tested */
//    ZCCRYPT_MODE_CFB=3,
//    ZCCRYPT_MODE_OFB=4,
//#endif
//    ZCCRYPT_MODE_DUMMY=0x7FFFFFFF  /* force enum to use 32 bit values */
//} ZCCRYPT_MODE;
type  ZCCRYPT_MODE = LongInt;
Const ZCCRYPT_MODE_ECB = $1;
      ZCCRYPT_MODE_CBC = $2;
      ZCCRYPT_MODE_CFB = $3;
      ZCCRYPT_MODE_OFB = $4;

// /* ECC 161 */
//typedef struct _ZCCRYPT_EC161DOMAINPARAMS
//  {
//  BYTE a ;
//  BYTE b[21] ;
//  BYTE r[21] ;
//  BYTE k ;
//  BYTE Gx[21] ;
//  BYTE Gy ;
//  } ZCCRYPT_EC161DOMAINPARAMS;
type ZCCRYPT_EC161DOMAINPARAMS = packed record
                                  a : byte;
                                  b : array[0..20] of byte;
                                  r : array[0..20] of byte;
                                  k : byte;
                                  Gx: array[0..20] of byte;
                                  Gy: byte;
                               end;
//typedef ZCCRYPT_EC161DOMAINPARAMS *PZCCRYPT_EC161DOMAINPARAMS;
     PZCCRYPT_EC161DOMAINPARAMS = ^ZCCRYPT_EC161DOMAINPARAMS;
//typedef BYTE ZCCRYPT_EC161PRIVATEKEY[21];
     ZCCRYPT_EC161PRIVATEKEY = array[0..20] of byte;
//typedef BYTE *PZCCRYPT_EC161PRIVATEKEY;
     PZCCRYPT_EC161PRIVATEKEY = PBYTE;
//typedef BYTE ZCCRYPT_EC161PUBLICKEY[22];
     ZCCRYPT_EC161PUBLICKEY = array[0..21] of byte;
//typedef BYTE *PZCCRYPT_EC161PUBLICKEY;
     PZCCRYPT_EC161PUBLICKEY = PBYTE;
//typedef BYTE ZCCRYPT_EC161SIGNATURE[42];
     ZCCRYPT_EC161SIGNATURE = array[0..41] of byte;
//typedef BYTE *PZCCRYPT_EC161SIGNATURE;
     PZCCRYPT_EC161SIGNATURE = PBYTE;
//typedef BYTE ZCCRYPT_EC161SHAREDSECRET[21];
     ZCCRYPT_EC161SHAREDSECRET = array[0..20] of byte;
//typedef BYTE *PZCCRYPT_EC161SHAREDSECRET;
     PZCCRYPT_EC161SHAREDSECRET = PBYTE;
//typedef BYTE ZCCRYPT_EC161SESSIONKEY[20];
     ZCCRYPT_EC161SESSIONKEY = array[0..19] of byte;
//typedef BYTE *PZCCRYPT_EC161SESSIONKEY;
     PZCCRYPT_EC161SESSIONKEY = PBYTE;
//typedef void *ZCCRYPT_CONTEXT_EC161;
     ZCCRYPT_CONTEXT_EC161 = Pointer;
//typedef ZCCRYPT_CONTEXT_EC161 *PZCCRYPT_CONTEXT_EC161;

     PZCCRYPT_CONTEXT_EC161 = ^Pointer;
//#pragma pack()




// /* function prototypes */
// #ifdef ZCCRYPT_VER_1_0
{/******************************************************************************/
/* Function       : ZCCryptGetVer                                             */
/* Description    : Get version of this API                                   */
/* Parameter      : (OUT) *pVer  version number e.g. 0x100 for V1.0           */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/******************************************************************************/
/* History        : 20000128 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptGetVer(DWORD *pVer);
}
function ZCCryptGetVer(pVer : PDWORD) : ZCCRYPTRET;
                            stdcall;external 'ZCCRYPT.DLL' index 1;


//******************************************************************************/
//* Function       : ZCCryptDesCreateContext                                   */
//* Description    : Create encrytion context for use with DES/3DES            */
//* Parameter      : (OUT) *pContext  encryption context to use with further   */
//*                                   DES function calls                       */
//*                  (IN) algo  encryption algorithm either ZCCRYPT_ALGO_DES   */
//*                             ZCCRYPT_ALGO_3DES                              */
//*                  (IN) mode  encryption chaining mode (ZCCRYPT_MODE_...)    */
//*                             either .._ECB, .._CBC, .._CFB or .._OFB        */
//*                  (IN) *pIV  8 byte initial vector or NULL for {0, .., 0}   */
//*                  (IN) *pKey 8 byte key for .._DES, 16 byte key for .._3DES */
//* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
//*                  ZCCRYPT_ERROR_PARM  invalid parameter (pKey==NULL)        */
//******************************************************************************/
//* History        : 20000128 MP initial version                               */
//******************************************************************************/
//ZCCRYPTRET ZCCRYPTLINK ZCCryptDesCreateContext(PZCCRYPT_CONTEXT_DES pContext,
//                                               ZCCRYPT_ALGO algo,
//                                               ZCCRYPT_MODE mode,
//                                               const BYTE*        pIV,
//                                               const BYTE*        pKey);

function ZCCryptDesCreateContext(pContext : PZCCRYPT_CONTEXT_DES;
                                 algo : ZCCRYPT_ALGO;
                                 mode : ZCCRYPT_MODE;
                                 const pIV : PBYTE;
                                 const pKey: PBYTE) : ZCCRYPTRET;
                                 stdcall; external 'ZCCRYPT.DLL'
                                 index 20;

//******************************************************************************/
//* Function       : ZCCryptDesSetIV                                           */
//* Description    : Set IV, maybe used to reset context to start IV           */
//* Parameter      : (IN) Context  encryption context return by                */
//*                                ZCCryptDesCreateContext                     */
//*                  (IN) *pIV  8 byte initial vector or NULL for {0, .., 0}   */
//* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
//*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
//******************************************************************************/
//* History        : 20000131 MP initial version                               */
//******************************************************************************/
//ZCCRYPTRET ZCCRYPTLINK ZCCryptDesSetIV(ZCCRYPT_CONTEXT_DES Context,
//                                       const BYTE *pIV);
function ZCCryptDesSetIV(Context : ZCCRYPT_CONTEXT_DES;
                         const pIV : PBYTE):ZCCRYPTRET;
                         stdcall; external 'ZCCRYPT.DLL'
                         index 22;

{
/******************************************************************************/
/* Function       : ZCCryptDesGetIV                                           */
/* Description    : Get current active IV                                     */
/* Parameter      : (IN) Context  encryption context return by                */
/*                                ZCCryptDesCreateContext                     */
/*                  (OUT) *pIV  8 byte initial vector                         */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/******************************************************************************/
/* History        : 20000131 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptDesGetIV(ZCCRYPT_CONTEXT_DES Context,
                                       BYTE *pIV);
}
function ZCCryptDesGetIV(Context : ZCCRYPT_CONTEXT_DES;
                         pIV : PBYTE) :  ZCCRYPTRET;
                         stdcall; external 'ZCCRYPT.DLL'
                         index 23;


{
/******************************************************************************/
/* Function       : ZCCryptDesDestroyContext                                  */
/* Description    : Destroy encrytion context created by                      */
/*                  ZCCryptDesCreateContext this also destroy/clears all keys */
/* Parameter      : (IN) *pContext   encryption context to destroy            */
/*                                   DES function calls                       */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter (pKey==NULL)        */
/******************************************************************************/
/* History        : 20000131 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptDesDestroyContext(PZCCRYPT_CONTEXT_DES pContext);
}
function ZCCryptDesDestroyContext(pContext : PZCCRYPT_CONTEXT_DES) : ZCCRYPTRET;
                                           stdcall; external 'ZCCRYPT.DLL'
                                           index 21;


{
/******************************************************************************/
/* Function       : ZCCryptDesEncrypt                                         */
/* Description    : Encrypt n (multiple of 8 bytes / 64 bits) bytes           */
/* Parameter      : (IN) Context  encryption context return by                */
/*                                ZCCryptDesCreateContext                     */
/*                  (IN) pData   (pointer to) data to encrypt                 */
/*                  (IN) cbData  length of data to encrypt (must be multiple  */
/*                               of 8)                                        */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/******************************************************************************/
/* History        : 20000131 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptDesEncrypt(ZCCRYPT_CONTEXT_DES Context,
                                         void *pData,
                                         DWORD cbLen);
}
function ZCCryptDesEncrypt(Context : ZCCRYPT_CONTEXT_DES;
                           pData   : Pointer;
                           cbLen   : DWORD) : ZCCRYPTRET;
                           stdcall; external 'ZCCRYPT.DLL'
                           index 24;

{
/******************************************************************************/
/* Function       : ZCCryptDesDecrypt                                         */
/* Description    : Decrypt n (multiple of 8 bytes / 64 bits) bytes           */
/* Parameter      : (IN) Context  encryption context return by                */
/*                                ZCCryptDesCreateContext                     */
/*                  (IN) pData   (pointer to) data to decrypt                 */
/*                  (IN) cbData  length of data to encrypt (must be multiple  */
/*                               of 8)                                        */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/******************************************************************************/
/* History        : 20000131 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptDesDecrypt(ZCCRYPT_CONTEXT_DES Context,
                                         void *pData,
                                         DWORD cbData);
}
function ZCCryptDesDecrypt(Context : ZCCRYPT_CONTEXT_DES;
                           pData : Pointer;
                           cbData : DWORD) : ZCCRYPTRET;
                           stdcall; external 'ZCCRYPT.DLL'
                           index 25;


//******************************************************************************/
//* Function       : ZCCryptDesEncryptOnce                                     */
//* Description    : Encrypt n (multiple of 8 bytes / 64 bits) bytes           */
//* Parameter      : (IN) algo  encryption algorithm either ZCCRYPT_ALGO_DES   */
//*                             ZCCRYPT_ALGO_3DES                              */
//*                  (IN) mode  encryption chaining mode (ZCCRYPT_MODE_...)    */
//*                             either .._ECB, .._CBC, .._CFB or .._OFB        */
//*                  (IN) *pIV  8 byte initial vector or NULL for {0, .., 0}   */
//*                  (IN) *pKey 8 byte key for .._DES, 16 byte key for .._3DES */
//*                  (IN) pData   (pointer to) data to encrypt                 */
//*                  (IN) cbData  length of data to encrypt (must be multiple  */
//*                               of 8)                                        */
//* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
//*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
//******************************************************************************/
//* History        : 20000131 MP initial version                               */
//******************************************************************************/
//ZCCRYPTRET ZCCRYPTLINK ZCCryptDesEncryptOnce(ZCCRYPT_ALGO algo,
//                                             ZCCRYPT_MODE mode,
//                                             const BYTE*        pIV,
//                                             const BYTE*        pKey,
//                                             void *pData,
//                                             DWORD cbData);

function ZCCryptDesEncryptOnce(algo : ZCCRYPT_ALGO;
                               mode : ZCCRYPT_MODE;
                               const pIV : PBYTE;
                               const pKey : PBYTE;
                               pData : Pointer;
                               cbData : DWORD) : ZCCRYPTRET;
                               stdcall; external 'ZCCRYPT.DLL'
                               index 26;

//******************************************************************************/
//* Function       : ZCCryptDesDecryptOnce                                     */
//* Description    : Decrypt n (multiple of 8 bytes / 64 bits) bytes           */
//* Parameter      : (IN) algo  encryption algorithm either ZCCRYPT_ALGO_DES   */
//*                             ZCCRYPT_ALGO_3DES                              */
//*                  (IN) mode  encryption chaining mode (ZCCRYPT_MODE_...)    */
//*                             either .._ECB, .._CBC, .._CFB or .._OFB        */
//*                  (IN) *pIV  8 byte initial vector or NULL for {0, .., 0}   */
//*                  (IN) *pKey 8 byte key for .._DES, 16 byte key for .._3DES */
//*                  (IN) pData   (pointer to) data to encrypt                 */
//*                  (IN) cbData  length of data to encrypt (must be multiple  */
//*                               of 8)                                        */
//* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
//*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
//******************************************************************************/
//* History        : 20000131 MP initial version                               */
//******************************************************************************/
//ZCCRYPTRET ZCCRYPTLINK ZCCryptDesDecryptOnce(ZCCRYPT_ALGO algo,
//                                             ZCCRYPT_MODE mode,
//                                             const BYTE*        pIV,
//                                             const BYTE*        pKey,
//                                             void *pData,
//                                             DWORD cbData);
function ZCCryptDesDecryptOnce(algo : ZCCRYPT_ALGO;
                               mode : ZCCRYPT_MODE;
                               const pIV : PBYTE;
                               const pKey : PBYTE;
                               pData :  Pointer;
                               cbData : DWORD) : ZCCRYPTRET;
                               stdcall; external 'ZCCRYPT.DLL'
                               index 27;


{
/******************************************************************************/
/* Function       : ZCCryptDesStartCertificate                                */
/* Description    : Start certificate                                         */
/* Parameter      : (OUT) *pCert     encryption context to use with further   */
/*                                   DES certificate function calls           */
/*                  (IN) algo  encryption algorithm either ZCCRYPT_ALGO_DES   */
/*                             ZCCRYPT_ALGO_3DES                              */
/*                  (IN) *pKey 8 byte key for .._DES, 16 byte key for .._3DES */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter (pKey==NULL)        */
/******************************************************************************/
/* History        : 20000128 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptDesStartCertificate(PZCCRYPT_CONTEXT_DES_CERT pCert,
                                                  ZCCRYPT_ALGO algo,
                                                  const BYTE*        pKey);
}
function ZCCryptDesStartCertificate(pCert : PZCCRYPT_CONTEXT_DES_CERT;
                                    algo : ZCCRYPT_ALGO;
                                    const pKey : PBYTE) : ZCCRYPTRET;
                                    stdcall; external 'ZCCRYPT.DLL'
                                    index 28;


{
/******************************************************************************/
/* Function       : ZCCryptDesUpdateCertificate                               */
/* Description    : Extend certificate by append (encrypt) pData              */
/* Parameter      : (IN) Cert  Certificate context created by                 */
/*                             ZCCryptDesStartCertificate                     */
/*                  (IN) pData   (pointer to) data to use for update          */
/*                  (IN) cbData   length of data                              */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/******************************************************************************/
/* History        : 20000131 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptDesUpdateCertificate(ZCCRYPT_CONTEXT_DES_CERT Cert,
                                                   const void *pData,
                                                   DWORD cbData);
}
function ZCCryptDesUpdateCertificate(Cert : ZCCRYPT_CONTEXT_DES_CERT;
                                     const pData : Pointer;
                                     cbData : DWORD) : ZCCRYPTRET;
                                     stdcall; external 'ZCCRYPT.DLL'
                                     index 29;

{
/******************************************************************************/
/* Function       : ZCCryptDesEndCertificate                                  */
/* Description    : End certificate and get resulting certificate             */
/* Parameter      : (IN) pCert  Certificate context created by                */
/*                               ZCCryptDesStartCertificate                   */
/*                  (OUT) pResult resulting certificate (8 bytes), caller     */
/*                                must pass valid pointer to 8 byte buffer    */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/******************************************************************************/
/* History        : 20000131 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptDesEndCertificate(PZCCRYPT_CONTEXT_DES_CERT pCert,
                                               void *pResult);
}
function ZCCryptDesEndCertificate(pCert : PZCCRYPT_CONTEXT_DES_CERT;
                                  pResult : Pointer) : ZCCRYPTRET;
                                  stdcall; external 'ZCCRYPT.DLL'
                                  index 30;



{
/******************************************************************************/
/* Function       : ZCCryptDesCertificateOnce                                 */
/* Description    : Create certificate of data (*pData) in one step           */
/* Parameter      : (IN) algo  encryption algorithm either ZCCRYPT_ALGO_DES   */
/*                             ZCCRYPT_ALGO_3DES                              */
/*                  (IN) *pKey 8 byte key for .._DES, 16 byte key for .._3DES */
/*                  (IN) pData   (pointer to) data to certificate             */
/*                  (IN) cbData  length of data to certificate                */
/*                  (OUT) pResult resulting certificate (8 bytes), caller     */
/*                                must pass valid pointer to 8 byte buffer    */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/******************************************************************************/
/*                  20000204 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptDesCertificateOnce(ZCCRYPT_ALGO algo,
                                             const BYTE*        pKey,
                                             const void *pData,
                                             DWORD cbData, void *pResult);
}
function ZCCryptDesCertificateOnce(algo : ZCCRYPT_ALGO;
                                   const pKey : PBYTE;
                                   const pData : Pointer;
                                   cbData : DWORD;
                                   pResult : Pointer) : ZCCRYPTRET;
                                   stdcall; external 'ZCCRYPT.DLL'
                                   index 31;



{
/******************************************************************************/
/* Function       : ZCCryptShaStart                                           */
/* Description    : Start SHA use in conjunction with ..ShaAppend, ..ShaEnd   */
/* Parameter      : (OUT) *pSHAContext SHA context to use with further        */
/*                                     function calls                         */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/******************************************************************************/
/* History        : 20000204 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptShaStart(PZCCRYPT_CONTEXT_SHA pSHAContext);
}
function ZCCryptShaStart(pSHAContext : PZCCRYPT_CONTEXT_SHA) : ZCCRYPTRET;
                                       stdcall; external 'ZCCRYPT.DLL'
                                       index 40;


{
/******************************************************************************/
/* Function       : ZCCryptShaAppend                                          */
/* Description    : Append data to hash                                       */
/* Parameter      : (IN) SHAContext  context returned by ..ShaStart           */
/*                  (IN) pData       (pointer to) data to add                 */
/*                  (IN) cbData      length of data                           */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/******************************************************************************/
/* History        : 20000204 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptShaAppend(ZCCRYPT_CONTEXT_SHA SHAContext, const void *pData,
						DWORD cbData);
}
function ZCCryptShaAppend(SHAContext : ZCCRYPT_CONTEXT_SHA;
                          const pData : Pointer;
                          cbData : DWORD ) : ZCCRYPTRET;
                          stdcall; external 'ZCCRYPT.DLL'
                          index 41;
{
/******************************************************************************/
/* Function       : ZCCryptShaEnd                                             */
/* Description    : Close hash and get result (20 bytes)                      */
/* Parameter      : (IN) pSHAContext pointer to context returned by ..ShaStart*/
/*                  (OUT) pHash      resulting hash (20 bytes), caller must   */
/*                                   pass valid pointer to 20 byte buffer     */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/******************************************************************************/
/* History        : 20000204 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptShaEnd(PZCCRYPT_CONTEXT_SHA pSHAContext,
 						     void *pHash);
}
function ZCCryptShaEnd(pSHAContext : PZCCRYPT_CONTEXT_SHA;
                       pHash : Pointer) : ZCCRYPTRET;
                       stdcall; external 'ZCCRYPT.DLL'
                       index 42;


{
/******************************************************************************/
/* Function       : ZCCryptSha                                                */
/* Description    : Do secure hash                                            */
/* Parameter      : (IN) pData       (pointer to) data to add                 */
/*                  (IN) cbData      length of data                           */
/*                  (OUT) pHash      resulting hash (20 bytes), caller must   */
/*                                   pass valid pointer to 20 byte buffer     */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/******************************************************************************/
/* History        : 20000204 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptShaOnce(const void *pData,
						  DWORD cbData,
						  void *pHash);
}
function ZCCryptShaOnce(const pData : Pointer;
                        cbData : DWORD; pHash : Pointer) : ZCCRYPTRET;
                        stdcall; external 'ZCCRYPT.DLL'
                        index 43;


{
/******************************************************************************/
/* Function       : ZCCryptRandomInit                                         */
/* Description    : Initialize random generator                               */
/* Parameter      : none                                                      */
/* Returnvalue    : ZCCRYPT_NOERROR   no error                                */
/*                  ZCCRYPT_ERROR_MISC  unknown error occured                 */
/*                  ZCCRYPT_ERROR_RND_ALREADYINIT already initialized         */
/******************************************************************************/
/* History        : 20000210 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptRandomInit(void);
}
function ZCCryptRandomInit : ZCCRYPTRET; stdcall; external 'ZCCRYPT.DLL'
                                         index 60;


{
/******************************************************************************/
/* Function       : ZCCryptRandomTerm                                         */
/* Description    : Terminate random generator (required if ZCCryptRandomInit */
/*                  was called)                                               */
/* Parameter      : none                                                      */
/* Returnvalue    : ZCCRYPT_NOERROR   no error                                */
/*                  ZCCRYPT_ERROR_RND_NOTINIT random not initialized          */
/*                  ZCCRYPT_ERROR_MISC  unknown error occured                 */
/******************************************************************************/
/* History        : 20000210 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptRandomTerm(void);
}
function ZCCryptRandomTerm : ZCCRYPTRET; stdcall; external 'ZCCRYPT.DLL'
                                         index 61;

{
/******************************************************************************/
/* Function       : ZCCryptRandomSeed                                         */
/* Description    : Seed random generator                                     */
/* Parameter      : (IN) *pSeed   random data to seed random generator        */
/*                  (IN) cbSeed   size  of seed in bytes                      */
/* Returnvalue    : ZCCRYPT_NOERROR   no error                                */
/*                  ZCCRYPT_ERROR_RND_NOTINIT random not initialized          */
/*                  ZCCRYPT_ERROR_MISC  unknown error occured                 */
/*                  ZCCRYPT_ERROR_PARM invalid pointer pSeed                  */
/******************************************************************************/
/* History        : 20000210 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptRandomSeed(const void *pSeed,
						 DWORD cbSeed);
}
function ZCCryptRandomSeed(const pSeed : Pointer; cbSeed : DWORD) : ZCCRYPTRET;
                                 stdcall; external 'ZCCRYPT.DLL'
                                 index 62;


{
/******************************************************************************/
/* Function       : ZCCryptRandom                                             */
/* Description    : Get random data                                           */
/* Parameter      : (OUT) *pRandom   random data requested                    */
/*                  (IN)  cbRandom   number of requested bytes (max 40 byte)  */
/* Returnvalue    : ZCCRYPT_NOERROR   no error                                */
/*                  ZCCRYPT_ERROR_PARM to much random data requested or       */
/*                                     invalid pointer pRandom                */
/*                  ZCCRYPT_ERROR_RND_NOTINIT random not initialized          */
/*                  ZCCRYPT_ERROR_MISC  unknown error occured                 */
/******************************************************************************/
/* History        : 20000210 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptRandom(void *pRandom, DWORD cbRandom);
}
function ZCCryptRandom(pRandom : Pointer; cbRandom : DWORD) : ZCCRYPTRET;
                               stdcall; external 'ZCCRYPT.DLL'
                               index 63;


{
/******************************************************************************/
/* Function       : ZCCryptEC161CreateContext                                 */
/* Description    : Create EC161 context for use with further EC calls from   */
/*                  number (1-3) of ZeitControl ECC curves                    */
/* Parameter      : (OUT) *pEC161  Elliptic Curve context to use with further */
/*                                 EC161 function calls                       */
/*                  (IN) iCurve number (1 to 3) of predefined curve           */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/*                  ZCCRYPT_ERROR_MEM   out of memory                         */
/******************************************************************************/
/* History        : 20000208 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptEC161CreateContext(PZCCRYPT_CONTEXT_EC161 pEC161,
                                                                        int iCurve);
}
function ZCCryptEC161CreateContext(pEC161 : PZCCRYPT_CONTEXT_EC161; iCurve : integer)
                                          : ZCCRYPTRET;   stdcall; external 'ZCCRYPT.DLL'
                                          index 80;


{
/******************************************************************************/
/* Function       : ZCCryptEC161CreateContextFromParams                       */
/* Description    : Create EC161 context for use with further EC calls from   */
/*                  domain params                                             */
/* Parameter      : (OUT) *pEC161  Elliptic Curve context to use with further */
/*                                 EC161 function calls                       */
/*                  (IN) *pParams domain params                               */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/*                  ZCCRYPT_ERROR_MEM   out of memory                         */
/*                  ZCCRYPT_ERROR_EC161_BADPARAMS bad ecc params (*pParams)   */
/******************************************************************************/
/* History        : 20000208 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptEC161CreateContextFromParams
                                      (PZCCRYPT_CONTEXT_EC161 pEC161,
                                      const ZCCRYPT_EC161DOMAINPARAMS *pParams);
}
function ZCCryptEC161CreateContextFromParams(pEC161 : PZCCRYPT_CONTEXT_EC161;
                                             const pParams : PZCCRYPT_EC161DOMAINPARAMS)
                                             : ZCCRYPTRET; stdcall; external 'ZCCRYPT.DLL'
                                             index 81;

{
/******************************************************************************/
/* Function       : ZCCryptEC161DestroyContext                                */
/* Description    : Destroy EC161 context returned from                       */
/*                              ZCCryptEC161CreateContext or                  */
/*                              ZCCryptEC161CreateContextFromParams           */
/* Parameter      : (OUT) *pEC161  Elliptic Curve context to destroy          */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/******************************************************************************/
/* History        : 20000208 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptEC161DestroyContext(PZCCRYPT_CONTEXT_EC161 pEC161);
}
function ZCCryptEC161DestroyContext(pEC161 : PZCCRYPT_CONTEXT_EC161) : ZCCRYPTRET;
                                           stdcall; external 'ZCCRYPT.DLL'
                                           index 82

{
/******************************************************************************/
/* Function       : ZCCryptEC161GetPublicKey                                  */
/* Description    : Get public key from private key                           */
/* Parameter      : (IN) EC161  context returned from                         */
/*                              ZCCryptEC161CreateContext or                  */
/*                              ZCCryptEC161CreateContextFromParams           */
/*                  (IN) *pPrivateKey 21 byte private key                     */
/*                  (OUT) *pPrivateKey 21 byte corrected private key          */
/*                  (OUT) *pPublicKey 22 byte public key                      */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/*                  ZCCRYPT_ERROR_EC161_BADPARAMS invalid private key         */
/******************************************************************************/
/* History        : 20000208 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptEC161GetPublicKey(ZCCRYPT_CONTEXT_EC161 EC161,
                                           PZCCRYPT_EC161PRIVATEKEY pPrivateKey,
					   PZCCRYPT_EC161PUBLICKEY pPublicKey);
}
function  ZCCryptEC161GetPublicKey(EC161 : ZCCRYPT_CONTEXT_EC161;
                                   pPrivateKey : PZCCRYPT_EC161PRIVATEKEY;
                                   pPublicKey : PZCCRYPT_EC161PUBLICKEY) : ZCCRYPTRET;
                                   stdcall; external 'ZCCRYPT.DLL' index 83;


{
/******************************************************************************/
/* Function       : ZCCryptEC161SetupPrivateKey                               */
/* Description    : Make valid privat key from binary data                    */
/* Parameter      : (IN) EC161  context returned from                         */
/*                              ZCCryptEC161CreateContext or                  */
/*                              ZCCryptEC161CreateContextFromParams           */
/*                  (OUT) *pPrivateKey 21 byte private key                    */
/*                  (IN) *pKeyData     Key data to be used                    */
/*                  (IN) cbKeyData     Length of Key data                     */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/*                  ZCCRYPT_ERROR_EC161_BADPARAMS invalid private key         */
/******************************************************************************/
/* History        : 20000208 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptEC161SetupPrivateKey(ZCCRYPT_CONTEXT_EC161 EC161,
					    	PZCCRYPT_EC161PRIVATEKEY pPrivateKey,
					    void *pKeyData,
					    DWORD cbKeyData);
}
function ZCCryptEC161SetupPrivateKey(EC161 : ZCCRYPT_CONTEXT_EC161;
                                     pPrivateKey : PZCCRYPT_EC161PRIVATEKEY;
                                     pKeyData : Pointer;
                                     cbKeyData : DWORD) : ZCCRYPTRET;
                                     stdcall; external 'ZCCRYPT.DLL'
                                     index 89;


{
/******************************************************************************/
/* Function       : ZCCryptEC161GenerateKeyPair                               */
/* Description    : Get public key from private key                           */
/*                  You must have called ZCCryptRandomInit before             */
/* Parameter      : (IN) EC161  context returned from                         */
/*                              ZCCryptEC161CreateContext or                  */
/*                              ZCCryptEC161CreateContextFromParams           */
/*                  (OUT) *pPrivateKey 21 byte private key                    */
/*                  (OUT) *pPublicKey 22 byte public key                      */
/*                  (IN) *pSeed  seed for random generator or NULL            */
/*                               Note: It is strongly recommended to give some*/
/*                                     random seed                            */
/*                  (IN) cbSeed  size of seed in bytes                        */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error                              */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/*                  ZCCRYPT_ERROR_RND_NOTINIT random generator not initialized*/
/******************************************************************************/
/* History        : 20000208 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptEC161GenerateKeyPair(ZCCRYPT_CONTEXT_EC161 EC161,
						PZCCRYPT_EC161PRIVATEKEY pPrivateKey,
						PZCCRYPT_EC161PUBLICKEY pPublicKey,
						void *pSeed,
						DWORD cbSeed);
}
function ZCCryptEC161GenerateKeyPair (EC161 : ZCCRYPT_CONTEXT_EC161;
                                      pPrivateKey : PZCCRYPT_EC161PRIVATEKEY;
                                      pPublicKey  : PZCCRYPT_EC161PUBLICKEY;
                                      pSeed : Pointer;
                                      cbSeed : DWORD) : ZCCRYPTRET;
                                      stdcall; external 'ZCCRYPT.DLL'
                                      index 84;

{
/******************************************************************************/
/* Function       : ZCCryptEC161Verify                                        */
/* Description    : Verify EC161 signature                                    */
/* Parameter      : (IN) EC161  context returned from                         */
/*                              ZCCryptEC161CreateContext or                  */
/*                              ZCCryptEC161CreateContextFromParams           */
/*                  (IN) *pSignature 42 byte signature                        */
/*                  (IN) *pPublicKey signer's 22 byte public key              */
/*                  (IN) *pMessage 20 byte message to be verified             */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error, signature valid             */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/*                  ZCCRYPT_ERROR_EC161_BADPARAMS invalid public key          */
/*                  ZCCRYPT_ERROR_EC161_BADSIGNATURE invalid signature        */
/******************************************************************************/
/* History        : 20000208 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptEC161Verify(ZCCRYPT_CONTEXT_EC161 EC161,
					  const ZCCRYPT_EC161SIGNATURE *pSignature,
					  const ZCCRYPT_EC161PUBLICKEY *pPublicKey,
					  const void *pMessage);
}
function  ZCCryptEC161Verify(EC161 : ZCCRYPT_CONTEXT_EC161;
                             const pSignature : PZCCRYPT_EC161SIGNATURE;
                             const pPublicKey : PZCCRYPT_EC161PUBLICKEY;
                             const pMessage : Pointer) : ZCCRYPTRET;
                             stdcall; external 'ZCCRYPT.DLL'
                             index 85;


{
/******************************************************************************/
/* Function       : ZCCryptEC161HashAndVerify                                 */
/* Description    : Hash message and verify EC161 signature                   */
/* Parameter      : (IN) EC161  context returned from                         */
/*                              ZCCryptEC161CreateContext or                  */
/*                              ZCCryptEC161CreateContextFromParams           */
/*                  (IN) *pSignature 42 byte signature                        */
/*                  (IN) *pPublicKey signer's 22 byte public key              */
/*                  (IN) *pMessage   message to be verified                   */
/*                  (IN) cbMessage   size of message in bytes                 */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error, signature valid             */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/*                  ZCCRYPT_ERROR_EC161_BADPARAMS invalid public key          */
/*                  ZCCRYPT_ERROR_EC161_BADSIGNATURE invalid signature        */
/******************************************************************************/
/* History        : 20000208 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptEC161HashAndVerify(ZCCRYPT_CONTEXT_EC161 EC161,
					         const ZCCRYPT_EC161SIGNATURE *pSignature,
					         const ZCCRYPT_EC161PUBLICKEY *pPublicKey,
					         const void *pMessage,
					         DWORD cbMessage);
}
function ZCCryptEC161HashAndVerify(EC161 : ZCCRYPT_CONTEXT_EC161;
                                   const pSignature : PZCCRYPT_EC161SIGNATURE;
                                   const pPublicKey : PZCCRYPT_EC161PUBLICKEY;
                                   const pMessage : Pointer;
                                   cbMessage : DWORD) : ZCCRYPTRET;
                                   stdcall; external 'ZCCRYPT.DLL'
                                   index 86;


{
/******************************************************************************/
/* Function       : ZCCryptEC161SharedSecret                                  */
/* Description    : Calculate shared secret                                   */
/* Parameter      : (IN) EC161  context returned from                         */
/*                              ZCCryptEC161CreateContext or                  */
/*                              ZCCryptEC161CreateContextFromParams           */
/*                  (IN) *pPublicKey other party's 22-byte public key         */
/*                  (IN) *pPrivateKey own 21 byte private key                 */
/*                  (OUT) *pSecret 20 byte shared secret                      */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error, signature valid             */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/*                  ZCCRYPT_ERROR_EC161_BADPARAMS invalid key                 */
/******************************************************************************/
/* History        : 20000208 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptEC161SharedSecret(ZCCRYPT_CONTEXT_EC161 EC161,
						const ZCCRYPT_EC161PRIVATEKEY *pPrivateKey,
						const ZCCRYPT_EC161PUBLICKEY *pPublicKey,
						PZCCRYPT_EC161SHAREDSECRET pSecret);
}
function ZCCryptEC161SharedSecret(EC161 : ZCCRYPT_CONTEXT_EC161;
                                  const pPrivateKey : ZCCRYPT_EC161PRIVATEKEY;
                                  const pPublicKey : ZCCRYPT_EC161PUBLICKEY;
                                  pSecret : PZCCRYPT_EC161SHAREDSECRET) : ZCCRYPTRET;
                                  stdcall; external 'ZCCRYPT.DLL'
                                  index 87;


{
/******************************************************************************/
/* Function       : ZCCryptEC161SessionKey                                    */
/* Description    : Calculate a session key                                   */
/* Parameter      : (IN) EC161  context returned from                         */
/*                              ZCCryptEC161CreateContext or                  */
/*                              ZCCryptEC161CreateContextFromParams           */
/*                  (IN) *pPublicKey other party's 22-byte public key         */
/*                  (IN) *pPrivateKey own 21 byte private key                 */
/*                  (IN) *pKdp   key derivation parameter (binary data or     */
/*                               string of cbKdp byte length                  */
/*                  (IN) cbKdp   length of *pKdp                              */
/*                  (OUT) *pKey 20 byte session key                           */
/* Returnvalue    : ZCCRYPT_NOERROR     no_error, signature valid             */
/*                  ZCCRYPT_ERROR_PARM  invalid parameter                     */
/*                  ZCCRYPT_ERROR_EC161_BADPARAMS invalid key                 */
/******************************************************************************/
/* History        : 20000208 MP initial version                               */
/******************************************************************************/
ZCCRYPTRET ZCCRYPTLINK ZCCryptEC161SessionKey(ZCCRYPT_CONTEXT_EC161 EC161,
					  const ZCCRYPT_EC161PRIVATEKEY *pPrivateKey,
					  const ZCCRYPT_EC161PUBLICKEY *pPublicKey,
                                          const void *pKdp,
					  DWORD cbKdp,
					  PZCCRYPT_EC161SESSIONKEY pKey);
}
function ZCCryptEC161SessionKey(EC161 : ZCCRYPT_CONTEXT_EC161;
                                const pPrivateKey : PZCCRYPT_EC161PRIVATEKEY;
                                const pPublicKey : PZCCRYPT_EC161PUBLICKEY;
                                const pKdp : Pointer;
                                cbKdp : DWORD;
                                pKey : PZCCRYPT_EC161SESSIONKEY) : ZCCRYPTRET;
                                stdcall; external 'ZCCRYPT.DLL'
                                index 88;



//#endif /*  ZCCRYPT_VER_1_0 */


//#ifdef __cplusplus
//}
//#endif

//#endif

implementation



end.
